SystemOrganization addCategory: #'Glamour-Tests'!

GLMTransmission subclass: #GLMMockSimpleTransmission
	instanceVariableNames: 'wasTransmited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMMockSimpleTransmission classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/2/2009 21:24'!
new

	^super new initialize! !

!GLMMockSimpleTransmission methodsFor: 'testing' stamp: 'tg 1/14/2010 16:08'!
initialize
	super initialize.
	wasTransmited := false! !

!GLMMockSimpleTransmission methodsFor: 'testing' stamp: 'jorge.ressia 6/2/2009 21:26'!
transmit

	wasTransmited := true.
	super transmit.! !

!GLMMockSimpleTransmission methodsFor: 'testing' stamp: 'jre 9/18/2009 21:45'!
transmitIn: aContext

	wasTransmited := true.
	super transmitIn: aContext! !

!GLMMockSimpleTransmission methodsFor: 'testing' stamp: 'jorge.ressia 6/2/2009 21:23'!
wasTransmited
	^wasTransmited! !

GLMPane subclass: #GLMTestPane
	instanceVariableNames: 'seenTransmissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMTestPane classSide methodsFor: 'private' stamp: 'jorge.ressia 6/3/2009 08:55'!
new

	^super new initialize! !

!GLMTestPane classSide methodsFor: 'private' stamp: ' 4/5/09 22:18'!
portClass 
	 
	^GLMTestPort! !

!GLMTestPane methodsFor: 'accessing' stamp: 'tg 1/11/2010 21:59'!
browser
	browser isNil ifTrue: [ ^ GLMNoBrowser new ].
	^ browser! !

!GLMTestPane methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 21:37'!
browser: aBrowser 
	browser := aBrowser! !

Announcement subclass: #TestAnnouncement
	instanceVariableNames: 'parameter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!TestAnnouncement methodsFor: 'accessing' stamp: 'tg 2/22/2010 11:13'!
parameter
	^ parameter! !

!TestAnnouncement methodsFor: 'accessing' stamp: 'tg 2/22/2010 11:13'!
parameter: anObject
	parameter := anObject! !

GLMPanePort subclass: #GLMTestPort
	instanceVariableNames: 'seenTransmissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMTestPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
receive: aTransmission 
	 
	self seenTransmissions addLast: aTransmission. 
	^super receive: aTransmission! !

!GLMTestPort methodsFor: 'accessing' stamp: 'jre 9/18/2009 21:47'!
receive: aTransmission in: aContext
	 
	self seenTransmissions addLast: aTransmission. 
	^super receive: aTransmission in: aContext! !

!GLMTestPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
seenTransmissions 
	 
	^seenTransmissions ifNil: [seenTransmissions := OrderedCollection new]! !

TestCase subclass: #GLMAccumulatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMAccumulatorTest methodsFor: 'testing' stamp: 'tg 1/18/2010 14:46'!
testCopy
	| accumulator presentation copiedAccumulator |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator transmit fromOutside: #selection; toOutside: #otherPort.
	copiedAccumulator := accumulator copy.
	self assert: copiedAccumulator transmissions size = 1.
	self assert: copiedAccumulator transmissions first ~~ accumulator transmissions first.
	self assert: copiedAccumulator transmissions first destination pane == copiedAccumulator pane.
	self assert: copiedAccumulator transmissions first origins first pane ~~ accumulator pane.
	self assert: copiedAccumulator transmissions first origins first pane == copiedAccumulator pane! !

!GLMAccumulatorTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:49'!
testCustomTransmissions
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator transmit fromOutside: #selection; toOutside: #otherPort.
	accumulator startOn: 41.
	(accumulator panes first port: #selection) value: 42.
	self assert: (accumulator pane port: #otherPort) value = 42.! !

!GLMAccumulatorTest methodsFor: 'testing' stamp: 'tg 1/18/2010 09:53'!
testNoDuplicatePaneCreation
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator entity: 41.
	self assert: accumulator panes size = 1.
	accumulator entity: 42.
	self assert: accumulator panes size = 2.
	accumulator entity: 41.
	self assert: accumulator panes size = 2! !

!GLMAccumulatorTest methodsFor: 'testing' stamp: 'tg 1/18/2010 08:38'!
testPaneAddedAnnouncement
	| accumulator presentation annoumcementsCount |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	annoumcementsCount := 0.
	accumulator on: GLMPaneAdded do: [:ann | annoumcementsCount := annoumcementsCount + 1].
	1 to: 42 do: [ :i | accumulator entity: i ].
	self assert: annoumcementsCount = 42! !

!GLMAccumulatorTest methodsFor: 'testing' stamp: 'tg 8/22/2010 15:44'!
testPaneCreation
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator entity: 41.
	self assert: accumulator panes size = 1.
	self assert: (accumulator panes first port: #entity) value = 41.
	self assert: accumulator panes first presentations first rootPrototype == presentation.
	accumulator entity: 42.
	self assert: accumulator panes size = 2.
	self assert: (accumulator panes first port: #entity) value = 41.
	self assert: (accumulator panes last port: #entity) value = 42.
	self assert: accumulator panes first presentations first rootPrototype = presentation.
	self assert: accumulator panes last presentations first rootPrototype = presentation.
! !

!GLMAccumulatorTest methodsFor: 'testing' stamp: 'tg 1/18/2010 08:43'!
testPaneRemovedAnnouncement
	| accumulator presentation annoumcementsCount |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	annoumcementsCount := 0.
	accumulator on: GLMPaneRemoved do: [:ann | annoumcementsCount := annoumcementsCount + 1].
	1 to: 42 do: [ :i | accumulator entity: i ].
	self assert: annoumcementsCount = 0.
	1 to: 42 do: [ :i | accumulator removePaneIndex: 1 ].
	self assert: annoumcementsCount = 42! !

!GLMAccumulatorTest methodsFor: 'testing' stamp: 'tg 1/19/2010 21:21'!
testPaneSelectedAnnouncement
	| accumulator presentation annoumcementsCount otherAnnoumcementsCount |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	annoumcementsCount := 0.
	otherAnnoumcementsCount := 0.
	1 to: 42 do: [ :i | accumulator entity: i ].
	accumulator on: GLMPaneSelected do: [:ann | annoumcementsCount := annoumcementsCount + 1].
	accumulator on: GLMPaneAdded do: [:ann | otherAnnoumcementsCount := otherAnnoumcementsCount + 1].
	accumulator on: GLMPaneRemoved do: [:ann | otherAnnoumcementsCount := otherAnnoumcementsCount + 1].
	self assert: annoumcementsCount = 0.
	self assert: otherAnnoumcementsCount = 0.
	1 to: 42 do: [ :i | accumulator entityToSelect: i ].
	self assert: annoumcementsCount = 42.
	self assert: otherAnnoumcementsCount = 0.! !

!GLMAccumulatorTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:49'!
testPublishToOutside
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator startOn: 41.
	(accumulator panes first port: #selection) value: 42.
	self assert: (accumulator pane port: #selection) value = 42! !

!GLMAccumulatorTest methodsFor: 'testing' stamp: 'tg 1/18/2010 15:30'!
testPublishToOutsideWhenEmbedded
	| browser accumulator actualAccumulator |
	browser := GLMTabulator new.
	accumulator := GLMAccumulator new.
	accumulator addPresentation: GLMPresentation new.
	accumulator addTransmission: (GLMTransmission new
			addActiveOrigin: (GLMPresentationBoundPort new
								presentation: accumulator; 
								name: #selection; 
								yourself);
			destination: (GLMPresentationBoundPort new
								presentation: accumulator; 
								name: #anotherPort; 
								yourself);
			yourself).
	browser addColumn: #one.
	browser addTransmission: (GLMTransmission new 
			ensureNoOverrideBundleStrategy;
			addActiveOrigin: (GLMPresentationBoundPort new
								presentation: browser; 
								name: #entity; 
								yourself);
			destination: ((browser paneNamed: #one) port: #entity);
			addPresentation: accumulator;
			yourself).
	browser startOn: 41.
	actualAccumulator := browser panes first presentations first.
	(actualAccumulator panes first port: #selection) value: 42.
	self assert: (actualAccumulator pane port: #selection) value = 42.
	self assert: (actualAccumulator pane port: #anotherPort) value notNil.
	self assert: (actualAccumulator pane port: #anotherPort) value = 42! !

TestCase subclass: #GLMAnnouncementPropagationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMAnnouncementPropagationTest methodsFor: 'setup' stamp: 'tg 8/22/2010 17:45'!
expectedFailures
	^ #(testEntityPropogationAnnouncements)! !

!GLMAnnouncementPropagationTest methodsFor: 'setup' stamp: 'tg 5/24/2010 17:26'!
setUp
	GLMLogger instance: GLMMemoryLogger new! !

!GLMAnnouncementPropagationTest methodsFor: 'setup' stamp: 'tg 5/24/2010 17:27'!
tearDown
	GLMLogger reset! !

!GLMAnnouncementPropagationTest methodsFor: 'tests' stamp: 'tg 8/21/2010 23:47'!
testEntityPropogationAnnouncements 
	"This tests the order in which announcements are raised in nested browsers. 
 
	This is of importance as, in this test, we add a browser to a pane when a 
	certain port of that pane gets updated using a BundleTransmission but this 
	browser has a transmission from its #outer pane that refers to the same 
	port.  In such a case we want the presentation to be set first so that it can 
	be notified when the outer port changes. 
 
	This is a sister test to testEntityPropogation that ensures that the 
	announcements are raised in the right order and not redundantly." 
	 
	| browser1 browser2 | 
	browser1 := GLMTabulator new title: '1'; yourself. 
	browser2 := GLMTabulator new title: '2'; yourself. 
	browser1 pane name: 'b1 parent pane'. 
	browser1 column: #'b1-pane'.
	browser2 column: #'b2-pane'.
	self assert: browser1 pane presentations size = 1. 
	self assert: browser1 pane presentations first == browser1. 
	browser1 transmit to: #'b1-pane'; andShow: [:a | a custom: browser2].
	browser2 transmit to: #'b2-pane'; andShow: [:a | a text].
	self assert: GLMLogger instance announcements copy isEmpty. 
	browser1 startOn: 42. 
	
	self assert: GLMLogger instance announcements copy size = 12.	"1. The outer browser's outer pane changes its value." 

	self assert: ((GLMLogger instance announcements copy at: 1) isKindOf: GLMContextChanged). 
	self assert: (GLMLogger instance announcements copy at: 1) presentation == browser1. 
	self assert: (GLMLogger instance announcements copy at: 1) property = #entity. 
	self assert: (GLMLogger instance announcements copy at: 1) value = 42.	"2. The jumpstart transmission of the outer browser is triggered, updating the presentations..." 
	self assert: ((GLMLogger instance announcements copy at: 2) isKindOf: GLMPresentationsChanged). 
	self assert: (GLMLogger instance announcements copy at: 2) pane == browser1 panes first. 
	self assert: (GLMLogger instance announcements copy at: 2) oldPresentations isEmpty. 
	self assert: (GLMLogger instance announcements copy at: 2) presentations size = 1. 
	self assert: (GLMLogger instance announcements copy at: 2) presentations first = browser2.	"3. ...and then the context." 
	self assert: ((GLMLogger instance announcements copy at: 3) isKindOf: GLMContextChanged). 
	self assert: (GLMLogger instance announcements at: 3) presentation = browser2. 
	self assert: (GLMLogger instance announcements at: 3) property = #entity. 
	self assert: (GLMLogger instance announcements at: 3) value = 42.	"4. The jumpstart transmission of the inner browser is triggered, updating the presentations..." 
	self assert: ((GLMLogger instance announcements at: 4) isKindOf: GLMPresentationsChanged). 
	self assert: (GLMLogger instance announcements at: 4) pane == browser2 panes first. 
	self assert: (GLMLogger instance announcements at: 4) oldPresentations isEmpty. 
	self assert: (GLMLogger instance announcements at: 4) presentations size = 1. 
	self assert: (GLMLogger instance announcements at: 4) presentations first isNil.	"5. ...and then the context." 
	self assert: ((GLMLogger instance announcements at: 5) isKindOf: GLMContextChanged). 
	self assert: (GLMLogger instance announcements at: 5) presentation isNil. 
	self assert: (GLMLogger instance announcements at: 5) property = #entity. 
	self assert: (GLMLogger instance announcements at: 5) value = 42.	"6. Due to the context change of 5, the innermost presentation now matches." 
	self assert: ((GLMLogger instance announcements at: 6) isKindOf: GLMMatchingPresentationsChanged). 
	self assert: (GLMLogger instance announcements at: 6) pane == browser2 panes first. 
	self assert: (GLMLogger instance announcements at: 6) oldMatchingPresentations isEmpty. 
	self assert: (GLMLogger instance announcements at: 6) matchingPresentations size = 1. 
	self assert: (GLMLogger instance announcements at: 6) matchingPresentations first isNil.	"7. Due to the context change of 3, the inner browser now matches." 
	self assert: ((GLMLogger instance announcements at: 7) isKindOf: GLMMatchingPresentationsChanged). 
	self assert: (GLMLogger instance announcements at: 7) pane == browser1 panes first. 
	self assert: (GLMLogger instance announcements at: 7) oldMatchingPresentations isEmpty. 
	self assert: (GLMLogger instance announcements at: 7) matchingPresentations size = 1. 
	self assert: (GLMLogger instance announcements at: 7) matchingPresentations first == browser2.	"8. Due to the context change of 1, the outer browser now matches." 
	self assert: ((GLMLogger instance announcements at: 8) isKindOf: GLMMatchingPresentationsChanged). 
	self assert: (GLMLogger instance announcements at: 8) pane == browser1 pane. 
	self assert: (GLMLogger instance announcements at: 8) oldMatchingPresentations isEmpty. 
	self assert: (GLMLogger instance announcements at: 8) matchingPresentations size = 1. 
	self assert: (GLMLogger instance announcements at: 8) matchingPresentations first == browser1! !

!GLMAnnouncementPropagationTest methodsFor: 'tests' stamp: 'tg 5/24/2010 17:33'!
testSimple
	GLMPresentation new announce: GLMContextChanged new.
	self assert: GLMLogger instance announcements size = 1! !

!GLMAnnouncementPropagationTest methodsFor: 'tests' stamp: 'tg 8/22/2010 17:21'!
testSimpleEmptyPane
	| pane |
	pane := GLMPane new.
	pane browser: GLMBrowser new.
	(pane port: #entity) value: 42.
	self assert: GLMLogger instance announcements size = 1.
	self assert: (GLMLogger instance announcements first isKindOf: GLMContextChanged)! !

!GLMAnnouncementPropagationTest methodsFor: 'tests' stamp: 'tg 8/21/2010 23:28'!
testSimplePropagation
	| browser |
	browser := GLMTabulator new.
	browser column: #pane1.
	browser transmit to: #pane1; andShow: [:a | a text ].
	browser startOn: 42.
	self assert: GLMLogger instance announcements copy size = 8! !

TestCase subclass: #GLMAnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMAnnouncerTest methodsFor: 'as yet unclassified' stamp: 'tg 2/17/2010 23:20'!
setUp
	announcer := GLMAnnouncer new! !

!GLMAnnouncerTest methodsFor: 'as yet unclassified' stamp: 'tg 2/17/2010 23:59'!
testNestedSuspendAllWhile
	| announcement |
	announcer
		subscribe: TestAnnouncement
		do: [ :ann | announcement := ann ].
	
	announcement := nil.
	announcer suspendAllWhile: [
		announcer suspendAllWhile: [ ].
		announcer announce: TestAnnouncement ].
	self assert: announcement isNil! !

!GLMAnnouncerTest methodsFor: 'as yet unclassified' stamp: 'tg 2/17/2010 23:22'!
testSuspendAllWhile
	| announcement instance |
	announcer
		subscribe: TestAnnouncement
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: TestAnnouncement.
	self assert: announcement = instance.
	
	announcement := nil.
	announcer suspendAllWhile: [
		instance := announcer announce: TestAnnouncement ].
	self assert: announcement isNil! !

TestCase subclass: #GLMBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMBrowserTest methodsFor: 'as yet unclassified' stamp: 'tg 3/31/2010 21:49'!
testHasStatusbar
	| browser |
	browser := GLMBrowser new.
	self deny: browser hasStatusbar.
	browser hasStatusbar: true.
	self assert: browser panes size = 1.
	self assert: browser panes first name = GLMBrowser defaultStatusbarPane.
	self assert: browser statusbarPane == browser panes first! !

!GLMBrowserTest methodsFor: 'as yet unclassified' stamp: 'tg 1/11/2010 23:31'!
testNoComposite
	| browser |
	browser := GLMBrowser new.
	self assert: browser pane presentations size = 1.
	self assert: browser pane presentations first = browser.! !

!GLMBrowserTest methodsFor: 'as yet unclassified' stamp: 'tg 3/31/2010 20:37'!
testStatusbarTransmissions
	| browser pane |
	browser := GLMBrowser new.
	browser addStatusbar.
	pane := GLMPane new.
	browser addPane: pane.
	self assert: browser transmissions size = 1.
	self assert: browser transmissions first origins size = 1.
	self assert: browser transmissions first origins first = (pane port: #status).
	self assert: browser transmissions first destination = (browser panes first port: #entity).
	self assert: (browser transmissions first presentations first isKindOf: GLMLabelPresentation)! !

!GLMBrowserTest methodsFor: 'as yet unclassified' stamp: 'tg 3/31/2010 22:47'!
testStatusbarTransmissionsTriggered
	| browser pane |
	browser := GLMTabulator new.
	browser addStatusbar.
	self assert: browser statusbarPane notNil.
	self assert: browser statusbarPane ~= browser.
	pane := (GLMPane in: browser) name: #one.
	browser addPane: pane.
	self assert: browser transmissions size = 1.
	(pane port: #status) value: #test.
	self assert: browser statusbarPane ~= browser.
	self assert: (browser statusbarPane port: #entity) value = #test.
	self assert: (browser statusbarPane presentations size = 1).
	self assert: (browser statusbarPane presentations first isKindOf: GLMLabelPresentation)! !

!GLMBrowserTest methodsFor: 'as yet unclassified' stamp: 'tg 2/22/2010 11:05'!
testUnregisterAnnouncements
	| announcer presentation browser pane |
	announcer := Announcer new.
	browser := GLMBrowser new.
	pane := GLMPane new.
	presentation := GLMPresentation new.
	pane addPresentation: presentation.
	browser addPane: pane.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	presentation registerAnnouncements.
	self assert: (announcer instVarNamed: 'subscriptions') size = 1.
	browser unregisterFromAllAnnouncements.
	self assert: (announcer instVarNamed: 'subscriptions') isEmpty.
! !

!GLMBrowserTest methodsFor: 'as yet unclassified' stamp: 'tg 2/22/2010 11:05'!
testUnregisterAnnouncementsWhenRemovingPane
	| announcer presentation browser pane |
	announcer := Announcer new.
	browser := GLMBrowser new.
	pane := GLMPane new.
	presentation := GLMPresentation new.
	pane addPresentation: presentation.
	browser addPane: pane.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	presentation registerAnnouncements.
	self assert: (announcer instVarNamed: 'subscriptions') size = 1.
	browser removePane: pane.
	self assert: (announcer instVarNamed: 'subscriptions') isEmpty.
! !

TestCase subclass: #GLMBundleTransmissionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:40'!
testCopy
	| transmission newTransmission | 
	transmission := GLMTransmission new. 
	transmission addActiveOrigin: ((GLMSimplePort new) name: #port1; value: 1). 
	transmission addPassiveOrigin: ((GLMSimplePort new) name: #port2; value: 2). 
	transmission addActiveOrigin: ((GLMSimplePort new) name: #port3; value: 3). 
	transmission addPassiveOrigin: ((GLMSimplePort new) name: #port4; value: 4). 
	transmission destination: (GLMSimplePort new name: #port5). 

	newTransmission := transmission copy.
	
	self assert: transmission originReferences first ~= newTransmission originReferences first.! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:50'!
testPorts 
	"Tests that the origins are set up properly and that their order is retained." 
	| transmission | 
	transmission := GLMTransmission new. 
	transmission addActiveOrigin: (GLMSimplePort new name: #port1; value: 1). 
	transmission addPassiveOrigin: (GLMSimplePort new name: #port2; value: 2). 
	transmission 
		addActiveOrigin: 
			((GLMSimplePort new) 
				name: #port3; 
				value: 3). 
	transmission 
		addPassiveOrigin: 
			((GLMSimplePort new) 
				name: #port4; 
				value: 4). 
	transmission destination: (GLMSimplePort new name: #port5). 
	self assert: transmission originReferences size = 4. 
	transmission originReferences do: [:each | 
		self assert: (each isKindOf: GLMOriginPortReference)]. 
	self assert: (transmission originReferences at: 1) port name = #port1. 
	self assert: (transmission originReferences at: 2) port name = #port2. 
	self assert: (transmission originReferences at: 3) port name = #port3. 
	self assert: (transmission originReferences at: 4) port name = #port4. 
	self assert: transmission origins size = 4. 
	transmission origins do: [:each | 
		self assert: (each isKindOf: GLMSimplePort)]. 
	self assert: (transmission origins at: 1) name = #port1. 
	self assert: (transmission origins at: 2) name = #port2. 
	self assert: (transmission origins at: 3) name = #port3. 
	self assert: (transmission origins at: 4) name = #port4. 
	self assert: transmission activeOrigins size = 2. 
	transmission activeOrigins do: [:each | 
		self assert: (each isKindOf: GLMSimplePort)]. 
	self assert: (transmission activeOrigins at: 1) name = #port1. 
	self assert: (transmission activeOrigins at: 2) name = #port3. 
	self assert: transmission passiveOrigins size = 2. 
	transmission passiveOrigins do: [:each | 
		self assert: (each isKindOf: GLMSimplePort)]. 
	self assert: (transmission passiveOrigins at: 1) name = #port2. 
	self assert: (transmission passiveOrigins at: 2) name = #port4. 
	self assert: (transmission destination isKindOf: GLMSimplePort). 
	self assert: transmission destination name = #port5! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'tg 1/17/2010 16:17'!
testPresentations 
	"Tests that the presentations are set up correctly." 
	 
	| transmission presentation1 presentation2 presentation3 | 
	transmission := GLMTransmission new ensureBundleStrategy. 
	transmission addActiveOrigin: (GLMSimplePort new name: #port1; value: 1). 
	transmission addPassiveOrigin: (GLMSimplePort new name: #port2; value: 2). 
	transmission destination: (GLMSimplePort new name: #port3). 
	presentation1 := GLMPresentation new title: 'presentation1'. 
	presentation2 := GLMPresentation new title: 'presentation2'. 
	presentation3 := GLMPresentation new title: 'presentation3'. 
	transmission transmissionStrategy addPresentation: presentation1. 
	transmission transmissionStrategy addPresentation: presentation2. 
	transmission transmissionStrategy addPresentation: presentation3.	"Test correct setup" 
	self assert: transmission transmissionStrategy presentations size = 3. 
	self assert: (transmission transmissionStrategy presentations at: 1) == presentation1. 
	self assert: (transmission transmissionStrategy presentations at: 2) == presentation2. 
	self assert: (transmission transmissionStrategy presentations at: 3) == presentation3! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:50'!
testTransmitting 
	"Tests that the origins are set up properly and that their order is retained." 
	 
	| transmission | 
	transmission := GLMTransmission new. 
	transmission 
		addActiveOrigin: 
			((GLMSimplePort new) 
				name: #port1; 
				value: 1). 
	transmission destination: (GLMSimplePort new name: #port5). 
	self assert: transmission value = 1. 
	self assert: transmission destination value isNil. 
	transmission transmit. 
	self assert: transmission destination value = 1. 
	transmission 
		addPassiveOrigin: 
			((GLMSimplePort new) 
				name: #port2; 
				value: 2). 
	transmission 
		addActiveOrigin: 
			((GLMSimplePort new) 
				name: #port3; 
				value: 3). 
	transmission 
		addPassiveOrigin: 
			((GLMSimplePort new) 
				name: #port4; 
				value: 4). 
	self assert: transmission value = (GLMMultiValue withAll: #(1 2 3 4)). 
	transmission transmit. 
	self 
		assert: 
			transmission destination value = (GLMMultiValue withAll: #(1 2 3 4))! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'tg 1/31/2010 01:40'!
testTriggerConditions 
	"Tests that the transmission is triggered only when the active origins change." 
	 
	| transmission port1 port2 | 
	transmission := GLMTransmission new. 
	port1 := GLMSimplePort new name: #port1. 
	port2 := GLMSimplePort new name: #port2. 
	transmission addActiveOrigin: port1. 
	transmission addPassiveOrigin: port2. 
	transmission destination: (GLMPort new name: #port3). 
	self assert: (transmission originatesAt: port1). 
	self assert: (transmission originatesAt: port2) not! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:51'!
testTriggerConditionsWithParentPort 
	 
	| transmission presentation | 
	transmission := GLMTransmission new. 
	presentation := GLMPresentation new. 
	transmission 
		addActiveOrigin: 
			((GLMPresentationBoundPort new) 
				presentation: presentation; 
				name: #port1; 
				yourself). 
	self 
		assert: 
			(transmission 
				originatesAt: 
					((GLMPresentationBoundPort new) 
						presentation: presentation; 
						name: #port1; 
						yourself)). 
	self assert: (transmission originatesAt: (presentation pane port: #port1))! !

TestCase subclass: #GLMCompositePresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMCompositePresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 1/5/2010 15:18'!
testAdd
	| composite |
	composite := GLMCompositePresentation new.
	composite add: GLMPresentation new.
	self assert: composite isEmpty not.
	self assert: composite presentations size = 1! !

!GLMCompositePresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 1/5/2010 15:17'!
testCreation
	| composite |
	composite := GLMCompositePresentation new.
	self assert: composite isEmpty! !

!GLMCompositePresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 1/11/2010 09:11'!
testEquality
	| composite1 composite2 presentations |
	composite1 := GLMCompositePresentation new.
	composite2 := GLMCompositePresentation new.
	presentations := OrderedCollection with: GLMPresentation new with: GLMPresentation new.
	composite1 presentations: presentations.
	composite2 presentations: presentations.
	self assert: composite1 = composite2! !

!GLMCompositePresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 5/25/2010 14:34'!
testPane
	| pane composite presentation |
	pane := GLMPane new.
	composite := GLMCompositePresentation new.
	presentation := GLMPresentation new.
	composite add: presentation.
	composite pane: pane.
	self assert: composite pane == pane.
	self assert: composite first pane == pane! !

!GLMCompositePresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 1/11/2010 09:09'!
testSimpleEquality
	| composite1 composite2 |
	composite1 := GLMCompositePresentation new.
	composite2 := GLMCompositePresentation new.
	self assert: composite1 = composite2! !

TestCase subclass: #GLMDyanmicPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMDyanmicPresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 2/28/2010 23:28'!
testDefaultPresentation
	| dynamic |
	dynamic := GLMDynamicPresentation new.
	dynamic entity: 42.
	dynamic transformation: [ :entity |
		GLMTextPresentation new ].
	self assert: dynamic currentPresentation presentations size = 1.
	self assert: (dynamic currentPresentation presentations first isKindOf: GLMTextPresentation).
	self assert: dynamic currentPresentation pane == dynamic pane! !

!GLMDyanmicPresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 2/28/2010 23:33'!
testPresentationTransformation
	| dynamic |
	dynamic := GLMDynamicPresentation new.
	dynamic entity: 42.
	dynamic presentationTransformation: [ :some :entity |
		(1 to: entity) do: [ :each |
			some text title: each asString ] ].
	self assert: dynamic currentPresentation presentations size = 42.
	self assert: dynamic currentPresentation pane == dynamic pane! !

TestCase subclass: #GLMExpanderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMExpanderTest methodsFor: 'as yet unclassified' stamp: 'tg 5/1/2010 12:29'!
testCreation
	self assert: GLMExpander new panes isEmpty! !

TestCase subclass: #GLMExplicitBrowserCopyTest
	instanceVariableNames: 'browser copiedBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMExplicitBrowserCopyTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:52'!
setUp
	| pane1 pane2 transmission1 transmission2 | 
	browser := GLMExplicitBrowser new. 
	
	pane1 := browser addNewPane name: 'pane1'. 
	pane2 := browser addNewPane name: 'pane2'. 
	transmission1 := GLMTransmission new
		addActiveOrigin: (pane2 port: #selection); 
		destination: (GLMPresentationBoundPort new name: #selection; presentation: browser; yourself); 
		yourself.  
	browser addTransmission: transmission1. 
	transmission2 := GLMTransmission new 
		ensureBundleStrategy;
		addActiveOrigin: (pane1 port: #selection); 
		destination: (pane2 port: #entity); 
		addPresentation: (GLMPresentation new title: 'presentation1');
		yourself.  
	browser addTransmission: transmission2. 
	copiedBrowser := browser copy! !

!GLMExplicitBrowserCopyTest methodsFor: 'tests' stamp: 'tg 8/22/2010 15:45'!
testEquality
	self assert: (copiedBrowser = browser) not! !

!GLMExplicitBrowserCopyTest methodsFor: 'tests' stamp: 'tg 1/11/2010 22:39'!
testPanes
	self assert: copiedBrowser panes size = 2.
	self assert: copiedBrowser panes first ~~ browser panes first.
	self assert: copiedBrowser panes last ~~ browser panes last.

	self assert: copiedBrowser panes first browser == copiedBrowser.
	self assert: copiedBrowser panes last browser == copiedBrowser.

	self assert: copiedBrowser panes first ports size = 1.
	self assert: copiedBrowser panes first ports first name = #selection.
	self assert: copiedBrowser panes first ports first pane == copiedBrowser panes first.

	self assert: copiedBrowser panes last ports size = 2.
	self assert: copiedBrowser panes last ports first name = #selection.
	self assert: copiedBrowser panes last ports last name = #entity.! !

!GLMExplicitBrowserCopyTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:11'!
testTrasmissions
	self assert: copiedBrowser transmissions size = 2.
	self assert: copiedBrowser transmissions first ~~ browser transmissions first.
	self assert: copiedBrowser transmissions last ~~ browser transmissions last.

	self assert: (copiedBrowser transmissions first destination pane browser isKindOf: GLMNoBrowser).
	self assert: copiedBrowser transmissions last destination pane browser == copiedBrowser.
	
	self assert: (copiedBrowser transmissions first origins first pane browser == copiedBrowser).
	self assert: copiedBrowser transmissions last origins first pane browser == copiedBrowser! !

TestCase subclass: #GLMExplicitBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:10'!
testAddTransmissionReturn
	| transmission |
	transmission := GLMTransmission new.
	self assert: (GLMExplicitBrowser new addTransmission: transmission) == transmission! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'tg 8/22/2010 16:36'!
testJumpstartTransmission 
	 
	| browser presentation | 
	browser := GLMExplicitBrowser new. 
	presentation := GLMPresentation new. 
	browser addNewPane. 
	browser 
		addTransmission: 
			(GLMTransmission new
				ensureBundleStrategy;
				addActiveOrigin: (browser pane port: #entity); 
				destination: (browser panes first port: #entity); 
				addPresentation: presentation; 
				yourself). 
	self assert: (browser panes first port: #entity) value isNil. 
	self assert: browser panes first presentations isEmpty. 
	(browser pane port: #entity) value: #foo. 
	self assert: (browser panes first port: #entity) value = #foo. 
	self assert: browser panes first presentations size = 1. 
	self assert: browser panes first presentations first rootPrototype = presentation! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'tg 1/14/2010 12:25'!
testPresentationBoundPort 
	 
	| browser outerPort1 outerPort2 transmission1 transmission2 | 
	browser := GLMExplicitBrowser new. 
	browser addNewPane. 
	GLMTestPane new addPresentation: browser. 
	outerPort1 := (GLMPresentationBoundPort new) 
		presentation: browser; 
		name: #outerPort1; 
		yourself. 
	outerPort2 := (GLMPresentationBoundPort new) 
		presentation: browser; 
		name: #outerPort2; 
		yourself.	"Capturing" 
	browser 
		addTransmission: 
			(transmission1 := (GLMMockSimpleTransmission new) 
				addActiveOrigin: outerPort1; 
				destination: (browser panes first port: #innerPort1); 
				yourself).	"Publishing" 
	browser 
		addTransmission: 
			((transmission2 := GLMMockSimpleTransmission new) 
				addActiveOrigin: (browser panes first port: #innerPort2); 
				destination: outerPort2; 
				yourself). 
	(browser pane port: #outerPort1) value: 42. 
	self assert: (browser panes first port: #innerPort1) value = 42. 
	self assert: transmission1 wasTransmited.
	self deny: transmission2 wasTransmited.
	"self assert: (browser pane port: #outerPort1) seenTransmissions size = 0. "
	"self 
		assert: 
			((browser pane port: #outerPort1) seenTransmissions first isKindOf: 
					GLMSimpleTransmission). 
	self 
		assert: 
			((browser pane port: #outerPort1) seenTransmissions first origin isKindOf: 
					GLMSimplePort). 
	self 
		assert: 
			(browser pane port: #outerPort1) seenTransmissions first destination 
				== (browser pane port: #outerPort1). "
	"self 
		assert: 
			(browser panes first port: #innerPort1) seenTransmissions size = 1. 
	self 
		assert: 
			(browser panes first port: #innerPort1) seenTransmissions first 
				== browser transmissions first. "
	(browser panes first port: #innerPort2) value: 43. 
	self assert: (browser pane port: #outerPort2) value = 43. 
	"self 
		assert: 
			(browser panes first port: #innerPort2) seenTransmissions size = 0. "
	"self 
		assert: 
			((browser panes first port: #innerPort2) seenTransmissions first isKindOf: 
					GLMSimpleTransmission). 
	self 
		assert: 
			((browser panes first port: #innerPort2) seenTransmissions first origin 
				isKindOf: GLMSimplePort). 
	self 
		assert: 
			(browser panes first port: #innerPort2) seenTransmissions first destination 
				== (browser panes first port: #innerPort2). "
	"self assert: (browser pane port: #outerPort2) seenTransmissions size = 1. 
	self 
		assert: 
			(browser pane port: #outerPort2) seenTransmissions first 
				== browser transmissions last"! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:10'!
testSetup 
	 
	| browser pane1 pane2 transmission | 
	browser := GLMExplicitBrowser new. 
	
	pane1 := browser addNewPane. 
	pane2 := browser addNewPane. 
	transmission := (GLMTransmission new) 
		addActiveOrigin: (pane1 port: #selection); 
		destination: (pane2 port: #entity); 
		yourself.  
	browser addTransmission: transmission. 
	self assert: browser panes size = 2. 
	self assert: browser transmissions size = 1. 
	self assert: browser panes first == pane1. 
	self assert: browser panes last == pane2. 
	self assert: pane1 browser == browser. 
	self assert: pane2 browser == browser. 
	self assert: browser transmissions first == transmission! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'tg 1/14/2010 12:26'!
testSimpleTransmission 
	 
	| browser pane1 pane2 presentation1 presentation2 transmission announcement | 
	browser := GLMExplicitBrowser new. 
	presentation1 := GLMPresentation new. 
	presentation2 := GLMPresentation new. 
	pane1 := browser addNewPane. 
	pane2 := browser addNewPane. 
	pane1 addPresentation: presentation1. 
	pane2 addPresentation: presentation2. 
	transmission := (GLMMockSimpleTransmission new) 
		addActiveOrigin: (pane1 port: #selection); 
		destination: (pane2 port: #entity); 
		yourself. 
	browser addTransmission: transmission. 
	announcement := nil. 
	presentation2 
		when: GLMContextChanged 
		do: [:ann | announcement := ann]. 
	presentation1 selection: 'foo'. 
	self assert: transmission wasTransmited.
	"self assert: (pane1 port: #selection) seenTransmissions size = 0. 
	self assert: (pane2 port: #entity) seenTransmissions size = 1." 
	"self 
		assert: (pane1 port: #selection) seenTransmissions first ~~ transmission. "
	"self assert: (pane2 port: #entity) seenTransmissions first == transmission. "
	self assert: (pane1 port: #selection) value = 'foo'. 
	self assert: (pane2 port: #entity) value = 'foo'. 
	self assert: announcement notNil! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'tg 8/22/2010 16:37'!
testTransmissionBundle 
	 
	| browser pane1 pane2 pane3 presentation1 presentation2 transmission | 
	browser := GLMExplicitBrowser new. 
	presentation1 := GLMPresentation new. 
	presentation2 := GLMPresentation new. 
	pane1 := GLMTestPane new. 
	pane2 := GLMTestPane new. 
	pane3 := GLMTestPane new. 
	pane1 addPresentation: GLMPresentation new. 
	pane2 addPresentation: GLMPresentation new. 
	pane3 addPresentation: presentation1. 
	transmission := GLMTransmission new
		ensureBundleStrategy;
		addActiveOrigin: (pane1 port: #selection); 
		addPassiveOrigin: (pane2 port: #selection); 
		destination: (pane3 port: #entity); 
		addPresentation: presentation2; 
		yourself. 
	browser addPane: pane1. 
	browser addPane: pane2. 
	browser addPane: pane3. 
	browser addTransmission: transmission. 
	self assert: pane3 presentations size = 1. 
	self assert: pane3 presentations first == presentation1.	"The first should not trigger any transmission (passive) 
	but the second should." 
	pane2 presentations first selection: #foo. 
	pane1 presentations first selection: #bar. 
	self assert: (pane1 port: #selection) seenTransmissions size = 0. 
	self assert: (pane2 port: #selection) seenTransmissions size = 0. 
	"self 
		assert: (pane1 port: #selection) seenTransmissions first ~~ transmission. 
	self 
		assert: (pane2 port: #selection) seenTransmissions first ~~ transmission." 
	self assert: (pane3 port: #entity) seenTransmissions size = 1. 
	"self assert: (pane3 port: #entity) seenTransmissions first ~~ transmission." 
	"self assert: (pane3 port: #entity) seenTransmissions first value = nil. "
	self assert: (pane3 port: #entity) seenTransmissions last == transmission. 
	self 
		assert: 
			(pane3 port: #entity) value = (GLMMultiValue withAll: #(#bar #foo)). 
	self assert: pane3 presentations size = 1. 
	self assert: pane3 presentations first rootPrototype = presentation2! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:10'!
testTriggeringConditions 
	 
	| browser pane1 pane2 transmission | 
	browser := GLMExplicitBrowser new. 
	browser pane: GLMTestPane new. 
	pane1 := GLMTestPane new. 
	pane2 := GLMTestPane new. 
	transmission := (GLMTransmission new) 
		addActiveOrigin: (pane1 port: #selection); 
		destination: (pane2 port: #entity); 
		yourself. 
	browser addPane: pane1. 
	browser addPane: pane2. 
	browser addTransmission: transmission. 
	self assert: (pane1 port: #selection) seenTransmissions isEmpty. 
	self assert: (pane2 port: #entity) seenTransmissions isEmpty. 
	(pane1 port: #selection) value: 12. 
	self assert: (pane1 port: #selection) seenTransmissions size = 0. 
	"self 
		assert: 
			((pane1 port: #selection) seenTransmissions first isKindOf: 
					GLMSimpleTransmission). "
	self assert: (pane2 port: #entity) seenTransmissions size = 1. 
	self assert: (pane2 port: #entity) seenTransmissions first == transmission.	"Setting the same value should re-publish but not trigger inner transmissions." 
	(pane1 port: #selection) value: 12. 
	self assert: (pane1 port: #selection) seenTransmissions size = 0. 
	"self 
		assert: 
			((pane1 port: #selection) seenTransmissions first isKindOf: 
					GLMSimpleTransmission). "
	"self 
		assert: 
			((pane1 port: #selection) seenTransmissions last isKindOf: 
					GLMSimpleTransmission). "
	self assert: (pane2 port: #entity) seenTransmissions size = 1. 
	self assert: (pane2 port: #entity) seenTransmissions first == transmission! !

TestCase subclass: #GLMExtensionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMExtensionsTest methodsFor: 'tests' stamp: ' 4/5/09 22:18'!
testGlamourValue 
	"Block closure" 
	 
	self assert: ([#foo] glamourValue: #(1 2)) = #foo. 
	self 
		assert: ([:first | Array with: first] glamourValue: #(1 2)) = #(#(1 2)). 
	self 
		assert: 
			([:first :second | Array with: first with: second] glamourValue: #(1 2)) = 
					#(#(1 2) nil). 
	self 
		assert: 
			([:first :second | Array with: first with: second] 
				glamourValue: (GLMMultiValue with: 1 with: 2)) = #(1 2).	"Symbol" 
	self assert: (#yourself glamourValueWithArgs: #(1 2)) = 1. 
	self assert: (#yourself glamourValueWithArgs: #()) = nil	"self assert: (#yourself glamourValue: (MultiValue with: 1 with: 2)) = 1."! !

!GLMExtensionsTest methodsFor: 'tests' stamp: ' 4/5/09 22:18'!
testGlamourValueWithArgs 
	"Block closure" 
	 
	self assert: ([#foo] glamourValueWithArgs: #(1 2)) = #foo. 
	self 
		assert: 
			([:first | Array with: first] glamourValueWithArgs: #(1 2)) = #(1). 
	self 
		assert: 
			([:first :second | Array with: first with: second] glamourValueWithArgs: 
					#(1 2)) = #(1 2). 
	self 
		assert: 
			([:first :second :third | Array with: first with: second with: third] 
				glamourValueWithArgs: #(1 2)) = #(1 2 nil).	"Symbol" 
	self assert: (#yourself glamourValueWithArgs: #(1 2)) = 1. 
	self assert: (#yourself glamourValueWithArgs: #()) = nil! !

TestCase subclass: #GLMFinderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMFinderTest methodsFor: 'tests' stamp: 'tg 3/31/2010 19:44'!
testEmptyPanes
	| browser | 
	browser := GLMFinder new. 
	self assert: browser panes isEmpty. 
	self assert: browser transmissions isEmpty.! !

!GLMFinderTest methodsFor: 'tests' stamp: 'tg 1/18/2010 07:42'!
testPaneCreation 
	| browser | 
	browser := GLMFinder new. 
	browser addPresentation: (GLMPresentation new title: 'presentation1'). 
	self assert: browser panes isEmpty.	"Outer entity changed." 
	(browser pane port: #entity) value: #value1. 
	self assert: browser panes size = 1. 
	self assert: browser panes first browser == browser. 
	self assert: (browser panes first port: #entity) value = #value1. 
	self assert: browser panes first presentations size = 1. 
	self assert: browser panes first presentations first title = 'presentation1'. 
	self assert: browser panes first presentations first ~~ browser presentations first.	"First pane selection changed." 
	(browser panes first port: #selection) value: #value2. 
	self assert: browser panes size = 2. 
	self assert: browser panes last browser == browser. 
	self assert: (browser panes last port: #entity) value = #value2. 
	self assert: browser panes last presentations first title = 'presentation1'. 
	self assert: browser panes last presentations first ~~ browser presentations first. 
	self assert: 
			browser panes last presentations first 
				~~ browser panes first presentations first.	"Second pane selection changed." 
	(browser panes last port: #selection) value: #value3. 
	self assert: browser panes size = 3. 
	self assert: browser panes last browser == browser. 
	self assert: (browser panes last port: #entity) value = #value3.	"First pane selection changed again." 
	(browser panes first port: #selection) value: #value4. 
	self assert: browser panes size = 2. 
	self assert: browser panes last browser == browser. 
	self assert: (browser panes last port: #entity) value = #value4.	"Outer entity changed again." 
	(browser pane port: #entity) value: #value5. 
	self assert: browser panes size = 1. 
	self assert: browser panes last browser == browser. 
	self assert: (browser panes last port: #entity) value = #value5! !

!GLMFinderTest methodsFor: 'tests' stamp: ' 4/5/09 22:18'!
testPortPublishing 
	 
	| browser | 
	browser := GLMFinder new. 
	(browser pane port: #entity) value: #value1. 
	self assert: browser panes size = 1. 
	self assert: browser pane ports size = 1. 
	self assert: (browser pane port: #entity) value = #value1. 
	(browser panes first port: #selection) value: #value2. 
	self assert: browser panes size = 2. 
	self assert: browser pane ports size = 2. 
	self assert: (browser pane port: #entity) value = #value1. 
	self assert: (browser pane port: #selection) value = #value2. 
	(browser panes last port: #selection) value: #value3. 
	self assert: browser panes size = 3. 
	self assert: browser pane ports size = 2. 
	self assert: (browser pane port: #entity) value = #value1. 
	self assert: (browser pane port: #selection) value = #value3. 
	(browser panes first port: #hover) value: #value4. 
	self assert: browser panes size = 3. 
	self assert: browser pane ports size = 3. 
	self assert: (browser pane port: #entity) value = #value1. 
	self assert: (browser pane port: #selection) value = #value3. 
	self assert: (browser pane port: #hover) value = #value4! !

!GLMFinderTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:50'!
testUnregisterAnnouncementsWhenRemovingPane
	| announcer browser presentation |
	announcer := Announcer new.
	browser := GLMFinder new.
	presentation := GLMPresentation new.
	presentation title: [:entity | entity].
	browser addPresentation: presentation.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	browser entity: #value1.
	browser panes first presentations first registerAnnouncements.
	self assert: ((announcer instVarNamed: 'subscriptions') at: TestAnnouncement) size = 1.
	self assert: ((announcer instVarNamed: 'subscriptions') at: TestAnnouncement) first receiver presentation = browser panes first presentations first.
	self assert: ((announcer instVarNamed: 'subscriptions') at: TestAnnouncement) first receiver presentation == browser panes first presentations first.
	(browser panes first port: #selection) value: #value2.
	browser panes last presentations first registerAnnouncements.
	self assert: ((announcer instVarNamed: 'subscriptions') at: TestAnnouncement) size = 2.
	self assert: ((announcer instVarNamed: 'subscriptions') at: TestAnnouncement) last receiver presentation = browser panes last presentations first.
	self assert: ((announcer instVarNamed: 'subscriptions') at: TestAnnouncement) last receiver presentation == browser panes last presentations first.
	(browser panes first port: #selection) value: #value3.
	self assert: ((announcer instVarNamed: 'subscriptions') at: TestAnnouncement) size = 1.! !

TestCase subclass: #GLMFlexiblePresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMFlexiblePresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 15:11'!
testDefault
	| browser |
	browser := GLMTabulator new.
	browser startOn: #(1 2 3).
	self assert: (browser panes first presentations first isKindOf: GLMFlexiblePresentation).
	browser startOn: 1.
	self assert: (browser panes first presentations first isKindOf: GLMFlexiblePresentation).! !

!GLMFlexiblePresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 2/28/2010 23:43'!
testDynamic
	| browser childBrowser |
	childBrowser := GLMFinder new.
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser custom: (GLMDynamicPresentation new display: [childBrowser]) ].
	browser startOn: 42.
	self assert: browser panes first presentations first currentPresentation first == childBrowser.
	self assert: childBrowser pane == browser panes first ! !

TestCase subclass: #GLMFormattedPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMFormattedPresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 9/9/2009 01:10'!
testFormat
	| presentation |
	presentation := GLMFormatedPresentation new.
	presentation format: [:c | c ].
	self assert: (presentation formatedDisplayValueOf: 1) = 1.
	presentation entity: 41.
	presentation format: [:a :c | a + c ].
	self assert: (presentation formatedDisplayValueOf: 1) = 42.
	presentation entity: (GLMMultiValue with: 20 with: 21).
	presentation format: [:a :b :c | a + b + c ].
	self assert: (presentation formatedDisplayValueOf: 1) = 42.
! !

TestCase subclass: #GLMHelperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMHelperTest methodsFor: 'as yet unclassified' stamp: 'tg 1/15/2010 00:43'!
testAsGlamorousMultiValue
	self assert: (GLMMultiValue with: #(1 2 3)) = (#(1 2 3) asGlamorousMultiValue).
	self assert: 
		(1 asGlamorousMultiValue, 2 asGlamorousMultiValue, 3 asGlamorousMultiValue) = 
		(GLMMultiValue withAll: #(1 2 3))! !

!GLMHelperTest methodsFor: 'as yet unclassified' stamp: 'tg 1/15/2010 00:44'!
testGlamourValue
	self assert: ([:a | a + 2 ] glamourValue: 40) = 42.
	self assert: ([:a | a + 2 ] glamourValue: 40 asGlamorousMultiValue) = 42.
	self assert: ([ 42 ] glamourValue: 40 asGlamorousMultiValue) = 42.

	self assert: ([:a | a first + a last ] glamourValue: #(40 2)) = 42.
	self assert: ([:a :b | a + b] glamourValue: (GLMMultiValue withAll: #(40 2))) = 42.
	self assert: ([:a | a + 2 ] glamourValue: (GLMMultiValue withAll: #(40 2))) = 42.
	self assert: ([ 42 ] glamourValue: (GLMMultiValue withAll: #(40 2))) = 42! !

TestCase subclass: #GLMListPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMListPresentationTest methodsFor: 'tests' stamp: 'tg 9/20/2009 15:19'!
testChildren
	| tree |
	tree := GLMTreePresentation new.
	tree transformation: [:aNumber | (1 to: aNumber ) collect: #printString ].
	tree children: [:each | self assert: (each isKindOf: String)  ].
	tree entity: 42.! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:50'!
testCustomValidation
	| pane presentation |
	pane := GLMPane named: 'test'.
	presentation := GLMListPresentation new.
	pane addPresentation: presentation.
	presentation customValidation: [ :object :aport :entity | 
		aport ~= #selection or: [object = (entity last + 40)] ].
	presentation entity: (OrderedCollection with: 1 with: 2).
	self assert: presentation entity last = 2.
	self assert: (presentation validate: 42 on: (pane port: #selection))! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'TestRunner 11/15/2009 16:08'!
testToSend
	| list |
	list := GLMListPresentation new.
	list selectionTransformation: [ :x | x + 1 ].
	list entity: ( 1 to: 100 ).
	list selection: 41.
	self assert: list selection = 42! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:50'!
testValidateOn
	| pane presentation |
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	pane addPresentation: presentation.
	presentation shouldValidate: true.
	presentation entity: ($a to: $d).
	self deny: (presentation validate: (Array with: $a) on: (pane port: #selection)).
	self deny: (presentation validate: (Array with: $a with: $b) on: (pane port: #selection)).
	self assert: (presentation validate: $a on: (pane port: #selection)).
	self assert: (presentation validate: $b on: (pane port: #selection)).
	self deny: (presentation validate: $z on: (pane port: #selection)).! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:50'!
testValidatePorts
	| pane presentation |
	pane := GLMPane named: 'test'.
	presentation := GLMListPresentation new.
	pane addPresentation: presentation.
	presentation shouldValidate: true.
	presentation entity: #(1 2).
	presentation selection: 2.
	self assert: presentation selection = 2.
	presentation selection: 3."this should be invalid"
	self assert: presentation selection = 2! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:50'!
testValidateWithMultipleSelection
	| pane presentation |
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	presentation beMultiple.
	presentation shouldValidate: true.
	pane addPresentation: presentation.
	presentation entity: ($a to: $d).
	self assert: (presentation validate: (Array with: $a) on: (pane port: #selection)).
	self assert: (presentation validate: (Array with: $a with: $b) on: (pane port: #selection)).
	self deny: (presentation validate: ($a) on: (pane port: #selection)).
	self deny: (presentation validate: (Array with: $z) on: (pane port: #selection)).! !

TestCase subclass: #GLMLoggerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMLoggerTest methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:13'!
testCustomInstance
	| memoryLogger |
	self assert: GLMLogger instance == GLMLogger nullInstance.
	memoryLogger := GLMMemoryLogger new.
	GLMLogger instance: memoryLogger.
	self assert: GLMLogger instance == memoryLogger.
	GLMLogger reset.
	self assert: GLMLogger instance == GLMLogger nullInstance! !

!GLMLoggerTest methodsFor: 'as yet unclassified' stamp: 'tg 5/24/2010 17:17'!
testDefault
	GLMLoggedObject withAllSubclassesDo: [ :each |
		self assert: each new logger == GLMLogger nullInstance ]! !

TestCase subclass: #GLMMondrianPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMMondrianPresentationTest methodsFor: 'as yet unclassified' stamp: 'tg 1/18/2010 20:27'!
testPaintingTakesPresentation
	| presentation viewRenderer  viewParameter mondrianParameter |
	presentation := GLMMondrianPresentation new.
	viewRenderer := MOViewRenderer new.
	presentation painting: [:view :entity :mondrian | viewParameter := view. mondrianParameter := mondrian ].
	presentation renderOn: viewRenderer.
	self assert: mondrianParameter notNil.
	self assert: mondrianParameter == presentation.
	self assert: viewParameter notNil.
	self assert: viewParameter == viewRenderer.! !

TestCase subclass: #GLMNestedBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMNestedBrowserTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:10'!
testChangeInnerSelection 
	"Tests setting the selection of an inner pane from the oustide. 
 
	The test sets up a browser with two panes. The first contains a 
	list of numbers, the second a browser which again contains one 
	pane with a list of the same numbers. When the selection in the 
	first pane changes, we want the same number to be selected in 
	the second pane. 
 
	To achieve this, we pull in a port on the second pane and copy 
	it to the inner pane using a simple transmission." 
	 
	| browser1 browser2 list1 list2 | 
	browser1 := GLMExplicitBrowser new. 
	browser2 := GLMExplicitBrowser new. 
	list1 := GLMListPresentation new. 
	list2 := GLMListPresentation new. 
	browser1 addNewPane. 
	browser1 addNewPane. 
	browser2 addNewPane. 
	browser1 panes first addPresentation: list1. 
	browser1 panes last addPresentation: browser2. 
	browser2 panes first addPresentation: list2. 
	browser1 
		addTransmission: 
			((GLMTransmission new) 
				addActiveOrigin: (browser1 panes first port: #selection); 
				destination: (browser1 panes last port: #innerSelection); 
				yourself). 
	browser2 
		addTransmission: 
			((GLMTransmission new) 
				addActiveOrigin: 
						((GLMPresentationBoundPort new) 
								presentation: browser2; 
								name: #innerSelection; 
								yourself); 
				destination: (browser2 panes first port: #selection); 
				yourself). 
	list1 entity: #(1 2 3). 
	list2 entity: #(1 2 3). 
	list1 selection: 1. 
	self assert: list2 selection = 1. 
	list1 selection: 2. 
	self assert: list2 selection = 2! !

!GLMNestedBrowserTest methodsFor: 'tests' stamp: 'tg 8/22/2010 16:37'!
testEntityPropogation 
	"This tests that the nested transmissions have the destination correctly set 
	to be in the pane from the outer browser." 
	 
	| browser1 browser2 presentation innerBrowser transmission1 transmission2 | 
	browser1 := GLMExplicitBrowser new. 
	browser2 := GLMExplicitBrowser new. 
	presentation := GLMPresentation new. 
	browser1 title: 'browser1'. 
	browser2 title: 'browser2'. 
	browser1 addNewPane name: 'pane1'. 
	browser2 addNewPane name: 'innerpane 1'.	"Jumpstart presentation for outer browser." 
	transmission1 := GLMTransmission new ensureBundleStrategy.
	transmission1 transmissionStrategy addPresentation: browser2. 
	browser1 addTransmission: (transmission1
				addActiveOrigin: (GLMPresentationBoundPort new 
								presentation: browser1; 
								name: #entity; 
								yourself); 
				destination: (browser1 panes first port: #entity); 
				yourself).	"Jumpstart presentation for inner browser." 
	transmission2 := GLMTransmission new ensureBundleStrategy.
	transmission2 transmissionStrategy addPresentation: presentation. 
	browser2 addTransmission: (transmission2
				addActiveOrigin: (GLMPresentationBoundPort new
								presentation: browser2; 
								name: #entity; 
								yourself); 
				destination: (browser2 panes first port: #entity); 
				yourself). 
	self assert: (browser1 pane port: #entity) value isNil. 
	self assert: browser1 panes size = 1. 
	self assert: (browser1 panes first port: #entity) value isNil. 
	self assert: browser1 panes first presentations isEmpty. 
	self assert: browser2 panes size = 1. 
	self assert: (browser2 panes first port: #entity) value isNil. 
	self assert: browser2 panes first presentations isEmpty. 
	(browser1 pane port: #entity) value: 42. 
	self assert: (browser1 pane port: #entity) value = 42. 
	self assert: browser1 panes size = 1.
	self assert: (browser1 panes first port: #entity) value = 42.
	self assert: browser1 panes first presentations size = 1. 
	innerBrowser := browser1 panes first presentations first.
	self assert: innerBrowser rootPrototype = browser2. 
	self assert: innerBrowser pane == browser1 panes first.
	self assert: innerBrowser panes size = 1.
	self assert: (innerBrowser panes first port: #entity) value = 42.
	self assert: innerBrowser panes first presentations size = 1.
	self assert: innerBrowser panes first presentations first rootPrototype = presentation! !

!GLMNestedBrowserTest methodsFor: 'tests' stamp: 'tg 1/14/2010 17:08'!
testInnerTransmissions
	"This tests that the nested transmissions have the destination correctly set 
	to be in the pane from the outer browser." 
	 
	| browser1 browser2 presentation innerBrowser | 
	browser1 := GLMExplicitBrowser new. 
	browser2 := GLMExplicitBrowser new. 
	presentation := GLMPresentation new. 
	browser1 addNewPane name: 'pane1'. 
	browser2 addNewPane name: 'innerpane 1'.	"Jumpstart presentation for outer browser." 
	browser1 addTransmission: 
			(GLMTransmission new
				ensureBundleStrategy;
				addActiveOrigin: 
						((GLMPresentationBoundPort new) 
								presentation: browser1; 
								name: #entity; 
								yourself); 
				destination: (browser1 panes first port: #entity); 
				addPresentation: browser2; 
				yourself).	"Jumpstart presentation for inner browser." 
	browser2 addTransmission: 
			(GLMTransmission new
				ensureBundleStrategy;
				addActiveOrigin: 
						((GLMPresentationBoundPort new) 
								presentation: browser2; 
								name: #entity; 
								yourself); 
				destination: (browser2 panes first port: #entity); 
				addPresentation: presentation; 
				yourself). 

	(browser1 pane port: #entity) value: 42. 
	innerBrowser := browser1 panes first presentations first.
	self assert: innerBrowser transmissions size = 1.
	self assert: (innerBrowser transmissions first origins first isKindOf: GLMPresentationBoundPort).
	self assert: innerBrowser transmissions first origins first pane == browser1 panes first! !

!GLMNestedBrowserTest methodsFor: 'tests' stamp: 'tg 6/12/2010 16:04'!
testNestedBrowsersWithMultipleOrigins
	| browser innerBrowser transmittedOne transmittedTwo|
	innerBrowser := GLMTabulator new.
	innerBrowser row: #inner.
	innerBrowser transmit to: #inner; andShow: [ :a | a text ].
	
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser transmit to: #three; from: #one; from: #two; andShow: [ :a | 
		a custom: 
			(innerBrowser
				display: [:one :two | 
					transmittedOne := one. 
					transmittedTwo := two ]) ].
	((browser paneNamed: #one) port: #selection) value: 1.
	((browser paneNamed: #two) port: #selection) value: 2.
	! !

TestCase subclass: #GLMNewScriptingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 1/14/2010 23:00'!
testBuildingNestedComposites
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one. 
	browser transmit to: #one; andShow: [ :a |
		a list.
		a text.
		a composite: [:another | 
			another text.
			another list ] ].
	browser startOn: 42.
	self assert: ((browser paneNamed: #one) presentations isKindOf: GLMCompositePresentation).
	self assert: (browser paneNamed: #one) presentations size = 3.
	self assert: ((browser paneNamed: #one) presentations last isKindOf: GLMCompositePresentation).
	self assert: (browser paneNamed: #one) presentations last size = 2! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 2/20/2010 14:17'!
testBundleTransmission
	| browser transmission | 
	browser := GLMTabulator new. 
	browser column: #one; column: #two; column: #three. 
	browser transmit from: #one -> #port1; from: #two -> #port2; to: #three -> #port3; andShow: [ :a |
		a list.
		a table ].
	transmission := browser transmissions first.
	self assert: browser transmissions size = 1.
	self assert: transmission browser == browser.
	self assert: (transmission transmissionStrategy isKindOf: GLMReplacePresentationsStrategy). 
	self assert: transmission origins size = 2.
	self assert: transmission origins first = ((browser paneNamed: #one) port: #port1). 
	self assert: transmission origins last = ((browser paneNamed: #two) port: #port2). 
	self assert: transmission destination = ((browser paneNamed: #three) port: #port3).
	self assert: (transmission transmissionStrategy presentations isKindOf: GLMCompositePresentation).
	self assert: transmission transmissionStrategy presentations size = 2! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 1/14/2010 23:00'!
testBundleTransmissionWithTransformation
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a | a text ].
	browser transmit from: #one transformed: [:x | x + 1 ]; to: #two; andShow: [ :a | a text ].
	browser startOn: 1.
	((browser paneNamed: #one) port: #selection) value: 41.
	
	self assert: ((browser paneNamed: #two) port: #entity) value = 42! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 1/15/2010 00:35'!
testEntity
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one. 
	browser transmit to: #one; andShow: [ :a | a list ].
	browser startOn: ($a to: $d).
	self assert: ((browser paneNamed: #one) port: #entity) value = ($a to: $d)! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 1/14/2010 23:00'!
testNestedCompositesPaneReference
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one. 
	browser transmit to: #one; andShow: [ :a |
		a list.
		a text.
		a composite: [:another | 
			another text.
			another list ] ].
	browser startOn: 42.
	(browser paneNamed: #one) presentations do: [:each |
		self assert: each pane == (browser paneNamed: #one) ].
	(browser paneNamed: #one) presentations last do: [:each |
		self assert: each pane == (browser paneNamed: #one) ]! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 1/14/2010 23:00'!
testSelectionValidation
	| browser |
	browser := GLMTabulator new.
	browser 
		column: [:c | c row:  #one; row: #two];
		column: #three.
	browser transmit to: #one; andShow: [:a |
		a list display: [:x | 1 to: x ]].
	browser transmit to: #two; from: #one; andShow: [:a |
		a list beMultiple; display: [:x | 1 to: x ] ].
	browser transmit to: #three; from: #two; andShow: [:a |
		a text ].
	browser startOn: 42.
	
	((browser paneNamed: #one) port: #selection) value: 40.
	self assert: ((browser paneNamed: #two) port: #entity) value = 40.
	((browser paneNamed: #two) port: #selection) value: #(10 30 40).
	self assert: ((browser paneNamed: #two) port: #selection) value = #(10 30 40).
	self assert: ((browser paneNamed: #three) port: #entity) value = #(10 30 40).

	((browser paneNamed: #two) port: #selection) value: #(10 30).
	self assert: ((browser paneNamed: #two) port: #selection) value = #(10 30).
	self assert: ((browser paneNamed: #three) port: #entity) value = #(10 30).

	((browser paneNamed: #one) port: #selection) value: 5.
	self assert: ((browser paneNamed: #two) port: #entity) value = 5.
	((browser paneNamed: #two) port: #selection) value: #(1 3).
	self assert: ((browser paneNamed: #two) port: #selection) value = #(1 3).
	self assert: ((browser paneNamed: #three) port: #entity) value = #(1 3).
! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 2/20/2010 14:07'!
testSimpleTransmission
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one; column: #two. 
	browser transmit from: #one -> #port1; fromOutside: #outerPort; to: #two -> #port2.
	browser transmit from: #one -> #port3; toOutside: #anotherOuterPort.
	self assert: browser transmissions size = 2.
	self assert: browser transmissions first browser == browser.
	self assert: (browser transmissions first transmissionStrategy isKindOf: GLMNoStrategy). 
	self assert: browser transmissions first origins first = ((browser paneNamed: #one) port: #port1). 
	self assert: browser transmissions first origins last = (browser pane port: #outerPort). 
	self assert: browser transmissions first destination = ((browser paneNamed: #two) port: #port2).

	self assert: browser transmissions last browser == browser.
	self assert: (browser transmissions last transmissionStrategy isKindOf: GLMNoStrategy).
	self assert: browser transmissions last origins first = ((browser paneNamed: #one) port: #port3).
	self assert: browser transmissions last destination = (browser pane port: #anotherOuterPort).
! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 1/31/2010 01:50'!
testSimpleTransmissionWithCondition
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one; column: #two. 
	browser transmit from: #one -> #port1; fromOutside: #entity; to: #two -> #port2; when: [:one :outer | 
		one notNil and: [outer notNil and: [one + outer = 42]]].
	browser startOn: 2.
	self assert: ((browser paneNamed: #two) port: #port2) value isNil.
	((browser paneNamed: #one) port: #port1) value: 39.
	self assert: ((browser paneNamed: #two) port: #port2) value isNil.
	((browser paneNamed: #one) port: #port1) value: 40.
	self assert: ((browser paneNamed: #two) port: #port2) value notNil! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 1/31/2010 01:53'!
testSimpleTransmissionWithTransformation
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one; column: #two. 
	browser transmit 
		from: #one -> #port1; 
		fromOutside: #entity; 
		to: #two -> #port2; 
		when: [:one :outer | one notNil and: [outer notNil]];
		transformed: [:one :outer | one + outer].
	browser startOn: 2.
	self assert: ((browser paneNamed: #two) port: #port2) value isNil.
	((browser paneNamed: #one) port: #port1) value: 40.
	self assert: ((browser paneNamed: #two) port: #port2) value = 42! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 1/14/2010 23:00'!
testStartTabulator
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one. 
	browser transmit to: #one; andShow: [ :a |
		a list.
		a text ].
	browser startOn: 42.
	self assert: ((browser paneNamed: #one) presentations isKindOf: GLMCompositePresentation).
	self assert: (browser paneNamed: #one) presentations size = 2! !

!GLMNewScriptingTest methodsFor: 'as yet unclassified' stamp: 'tg 4/1/2010 07:07'!
testStatusbar
	| browser |
	browser := GLMTabulator withStatusbar.
	browser row: #one.
	browser transmit to: #one; andShow: [:a | a list display: #(1 2 3)].
	self assert: (browser transmissions size = 2).
	browser startOn: 42.! !

TestCase subclass: #GLMNoBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMNoBrowserTest methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 08:35'!
testCreation

	self deny: GLMNoBrowser new isNil.
	self assert: (GLMNoBrowser new) == GLMNoBrowser new! !

TestCase subclass: #GLMPaneTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMPaneTest methodsFor: 'tests' stamp: 'tg 1/12/2010 13:53'!
expectedFailures
	^ #(testPortsInmmutability testPresentationsInmmutability)! !

!GLMPaneTest methodsFor: 'tests' stamp: 'jorge.ressia 6/2/2009 20:26'!
testCreation
	 
	| aPane | 
	aPane := GLMPane named: 1 in: 2. 
	self assert: aPane name = 1.
	self assert: aPane browser = 2.! !

!GLMPaneTest methodsFor: 'tests' stamp: 'tg 11/12/2009 22:01'!
testDefaultPortValue
	| pane |
	pane := GLMPane named: 'test'.
	self assert: (pane port: #somePort) value isNil! !

!GLMPaneTest methodsFor: 'tests' stamp: 'tg 1/5/2010 21:07'!
testDefaultPresentations
	| pane |
	pane := GLMPane named: 'test'.
	self assert: (pane presentations isKindOf: GLMCompositePresentation)! !

!GLMPaneTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:53'!
testDefaultValidate
	| pane |
	pane := GLMPane named: 'test'. 
	self assert: ((pane port: #selection) validate: 5)
! !

!GLMPaneTest methodsFor: 'tests' stamp: 'jorge.ressia 6/3/2009 09:13'!
testIn
	 
	| aPane | 
	aPane := GLMPane in: 1.
	self assert: aPane name = aPane defaultName.
	self assert: aPane browser = 1.
	self assert: aPane ports isEmpty.
	self assert: aPane presentations isEmpty.! !

!GLMPaneTest methodsFor: 'tests' stamp: 'jorge.ressia 6/3/2009 08:26'!
testNamed
	 
	| aPane | 
	aPane := GLMPane named: 1.
	self assert: aPane name = 1.
	self assert: aPane browser = GLMNoBrowser new.
	self assert: aPane ports isEmpty.
	self assert: aPane presentations isEmpty.! !

!GLMPaneTest methodsFor: 'tests' stamp: 'jorge.ressia 6/3/2009 08:05'!
testNamedIn
	 
	| aPane | 
	aPane := GLMPane named: 1 in: 2. 
	self assert: aPane name = 1.
	self assert: aPane browser = 2.
	self assert: aPane ports isEmpty.
	self assert: aPane presentations isEmpty.! !

!GLMPaneTest methodsFor: 'tests' stamp: 'jorge.ressia 6/3/2009 08:06'!
testPorts 
	 
	| pane port | 
	pane := GLMPane named: 'test'. 
	self assert: pane ports isEmpty. 
	port := pane port: #foo. 
	self assert: pane ports size = 1. 
	self assert: pane ports first == port. 
	self assert: (pane port: #foo) == port! !

!GLMPaneTest methodsFor: 'tests' stamp: 'jorge.ressia 6/3/2009 09:15'!
testPortsInmmutability
	 
	| aPane ports | 
	aPane := GLMPane in: 1.
	self assert: aPane ports isEmpty.
	ports := aPane ports.
	ports add: 1.
	self assert: ports size = 1.
	self assert: aPane ports isEmpty.! !

!GLMPaneTest methodsFor: 'tests' stamp: 'tg 8/22/2010 13:59'!
testPresentationAndBrowserConditions 
	 
	| pane presentation1 presentation2 presentation3 | 
	pane := GLMPane named: 'test'. 
	presentation1 := GLMExplicitBrowser new condition: [:first :second | first = 1 and: [second = 2]]. 
	presentation2 := GLMTabulator new condition: [:first | first = #foo]. 
	presentation3 := GLMExplicitBrowser new useExplicitNotNil. 
	pane addPresentation: presentation1. 
	pane addPresentation: presentation2. 
	pane addPresentation: presentation3. 
	(pane port: #entity) value: (GLMMultiValue withAll: #(1 2)). 
	self assert: pane matchingPresentations size = 2. 
	self assert: pane matchingPresentations first == presentation1. 
	self assert: pane matchingPresentations last == presentation3. 
	(pane port: #entity) value: (GLMMultiValue withAll: #(#foo 2)). 
	self assert: pane matchingPresentations size = 2. 
	self assert: pane matchingPresentations first == presentation2. 
	self assert: pane matchingPresentations last == presentation3. 
	(pane port: #entity) value: (GLMMultiValue withAll: #(nil 2)). 
	self assert: pane matchingPresentations size = 1! !

!GLMPaneTest methodsFor: 'tests' stamp: 'tg 9/11/2009 16:04'!
testPresentationConditions 
	 
	| pane presentation1 presentation2 presentation3 | 
	pane := GLMPane named: 'test'. 
	presentation1 := GLMPresentation new condition: [:first :second | first = 1 and: [second = 2]]. 
	presentation2 := GLMPresentation new condition: [:first | first = #foo]. 
	presentation3 := GLMPresentation new useExplicitNotNil. 
	pane addPresentation: presentation1. 
	pane addPresentation: presentation2. 
	pane addPresentation: presentation3. 
	(pane port: #entity) value: (GLMMultiValue withAll: #(1 2)). 
	self assert: pane matchingPresentations size = 2. 
	self assert: pane matchingPresentations first == presentation1. 
	self assert: pane matchingPresentations last == presentation3. 
	(pane port: #entity) value: (GLMMultiValue withAll: #(#foo 2)). 
	self assert: pane matchingPresentations size = 2. 
	self assert: pane matchingPresentations first == presentation2. 
	self assert: pane matchingPresentations last == presentation3. 
	(pane port: #entity) value: (GLMMultiValue withAll: #(nil 2)). 
	self assert: pane matchingPresentations size = 1! !

!GLMPaneTest methodsFor: 'tests' stamp: 'jorge.ressia 6/3/2009 08:07'!
testPresentations 
	 
	| pane presentation announcement | 
	pane := GLMPane named: 'test'. 
	presentation := GLMPresentation new. 
	self assert: pane presentations isEmpty. 
	announcement := nil. 
	pane whenPresentationsChanged: [:ann | announcement := ann]. 
	pane addPresentation: presentation. 
	self assert: pane presentations size = 1. 
	self assert: pane presentations first == presentation. 
	self assert: presentation pane == pane. 
	self assert: announcement notNil! !

!GLMPaneTest methodsFor: 'tests' stamp: 'jorge.ressia 6/3/2009 09:16'!
testPresentationsInmmutability
	 
	| aPane presentations | 
	aPane := GLMPane in: 1.
	self assert: aPane presentations isEmpty.
	presentations := aPane presentations.
	presentations add: 1.
	self assert: presentations size = 1.
	self assert: aPane presentations isEmpty.! !

!GLMPaneTest methodsFor: 'tests' stamp: 'jorge.ressia 6/3/2009 08:07'!
testSimplePresentations 
	 
	| pane presentation announcement | 
	pane := GLMPane named: 'test'. 
	presentation := GLMPresentation new. 
	self assert: pane presentations isEmpty. 
	announcement := nil. 
	pane whenPresentationsChanged: [:ann | announcement := ann]. 
	pane addPresentation: presentation. 
	self assert: pane presentations size = 1. 
	self assert: pane presentations first == presentation. 
	self assert: presentation pane == pane. 
	self assert: announcement notNil! !

!GLMPaneTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:53'!
testValidate
	| pane presentation |
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	pane addPresentation: presentation.
	presentation entity: (OrderedCollection with: 1 with: 2).
	presentation shouldValidate: true.
	self assert: ((pane port: #selection) validate: 1).
	self assert: ((pane port: #selection) validate: 2).
	self deny: ((pane port: #selection) validate: 5)
! !

TestCase subclass: #GLMPortEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMPortEventTest methodsFor: 'testing' stamp: 'jorge.ressia 5/30/2009 12:59'!
testCreation
	| anEvent |
	anEvent := GLMPortEvent 
		on: 1
		previouslyValued: 2.
	self assert: anEvent port = 1.
	self assert: anEvent oldValue = 2.
	self assert: anEvent transmissionContext isEmpty.! !

!GLMPortEventTest methodsFor: 'testing' stamp: 'jre 9/19/2009 11:36'!
testCreationWithTransmissionContext
	| anEvent aContext|
	aContext := OrderedCollection new.
	anEvent := GLMPortEvent 
		on: 1
		previouslyValued: 2
		in: aContext.
	self assert: anEvent port = 1.
	self assert: anEvent oldValue = 2.
	self assert: anEvent transmissionContext = aContext.! !

!GLMPortEventTest methodsFor: 'testing' stamp: 'tg 2/21/2010 01:23'!
testInterdependentPanesCycleBreak
	|browser outerCount oneCount |
	outerCount := 0.
	oneCount := 0.
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x*2]].
	browser showOn: #three; from: #two; using: [
		browser list
			display: [:x | 1 to: x*3];
			populate: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
	browser sendTo: #outer->#focus from: #three->#focus with: [:x | outerCount := outerCount + 1].
	browser sendTo: #one->#selection from: #outer->#focus with: [:x | oneCount := oneCount + 1].
	browser startOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.
	((browser paneNamed: #three) port: #selection) value: 12.
	((browser paneNamed: #three) port: #focus) value: 12.
	self assert: oneCount = 1.
	self assert: outerCount = 1.! !

!GLMPortEventTest methodsFor: 'testing' stamp: 'tg 2/21/2010 01:23'!
testInterdependentPanesProperPorts
	|browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x*2]].
	browser showOn: #three; from: #two; using: [
		browser list
			display: [:x | 1 to: x*3];
			populate: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
	browser sendTo: #outer->#focus from: #three->#focus.
	browser sendTo: #one->#selection from: #outer->#focus with: [:x | x + 1].
	browser sendTo: #two->#selection from: #outer->#focus with: [:x | x + 2].
	browser startOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.
	((browser paneNamed: #three) port: #selection) value: 12.
	((browser paneNamed: #three) port: #focus) value: 12.
	self assert: (browser pane port: #focus) value = 12.
	self assert: ((browser paneNamed: #one) port: #entity) value = 5.
	self assert: ((browser paneNamed: #one) port: #selection) value = 13.
	self assert: ((browser paneNamed: #two) port: #entity) value = 13.
	self assert: ((browser paneNamed: #two) port: #selection) value = 14.
	self assert: ((browser paneNamed: #three) port: #entity) value = 14.
	self assert: ((browser paneNamed: #three) port: #selection) value = nil.! !

!GLMPortEventTest methodsFor: 'testing' stamp: 'jorge.ressia 5/30/2009 12:02'!
testPortName
	| anEvent |
	anEvent := GLMPortEvent 
		on: ((GLMPort new) name: '1'; yourself)
		previouslyValued: 2.
	self assert: anEvent portName = '1'.
! !

TestCase subclass: #GLMPortReferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMPortReferenceTest methodsFor: 'testing' stamp: 'tg 1/5/2010 22:11'!
testOriginTransformedValue
	| port reference |
	port := GLMSimplePort new value: 41.
	reference := GLMOriginPortReference new port: port; transformation: [:x | x + 1 ].
	self assert: reference value = 42! !

!GLMPortReferenceTest methodsFor: 'testing' stamp: 'tg 1/5/2010 22:16'!
testOriginValue
	| port reference |
	port := GLMSimplePort new value: 42.
	reference := GLMOriginPortReference new port: port.
	self assert: reference value = 42! !

TestCase subclass: #GLMPortTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMPortTest methodsFor: 'tests' stamp: 'tg 11/19/2009 22:49'!
testPanePort 
	 
	| port | 
	port := GLMTestPane new port: #port1. 
	self assert: port seenTransmissions isEmpty. 
	port value: 42. 
"	self assert: port seenTransmissions size = 0. 
	self assert: port seenTransmissions first origin value = 42. 
	self assert: port seenTransmissions first origin ~= port. 
	self assert: port seenTransmissions first destination == port. 
	self assert: port value = 42"! !

!GLMPortTest methodsFor: 'tests' stamp: 'tg 1/5/2010 22:03'!
testPortEquality 
	 
	| presentation port | 
	presentation := GLMPresentation new. 
	port := (GLMPresentationBoundPort new) 
		name: #port; 
		presentation: presentation. 
	self assert: port = (presentation pane port: #port). 
	self assert: (presentation pane port: #port) = port. 
	self assert: port hash = (presentation pane port: #port) hash. 
	self assert: (presentation pane port: #port) hash = port hash! !

!GLMPortTest methodsFor: 'tests' stamp: 'tg 1/5/2010 22:09'!
testPresentationBoundPort 
	 
	| presentation port | 
	presentation := GLMPresentation new. 
	port := (GLMPresentationBoundPort new) 
		name: #port; 
		presentation: presentation. 
	port value: 42. 
	self assert: (presentation pane port: #port) value = 42. 
	(presentation pane port: #port) value: 43. 
	self assert: port value = 43! !

!GLMPortTest methodsFor: 'tests' stamp: ' 4/5/09 22:18'!
testSimplePort 
	 
	| port | 
	port := GLMSimplePort new. 
	port name: #foo. 
	port value: 42. 
	self assert: port name = #foo. 
	self assert: port value = 42. 
	self assert: port hasPane not! !

TestCase subclass: #GLMPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMPresentationTest methodsFor: 'tests' stamp: 'jorge.ressia 6/2/2009 23:44'!
testAnnouncement 
	 
	| pane presentation announcement | 
	pane := GLMPane named: 'test'. 
	presentation := GLMPresentation new. 
	pane addPresentation: presentation. 
	announcement := nil. 
	presentation 
		when: GLMContextChanged 
		do: [:ann | announcement := ann]. 
	(pane port: #entity) value: 42. 
	self assert: announcement notNil. 
	self assert: announcement property = #entity. 
	self assert: announcement value = 42! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'jorge.ressia 6/2/2009 23:44'!
testContext 
	 
	| pane presentation | 
	pane := GLMPane named: 'test'. 
	presentation := GLMPresentation new. 
	pane addPresentation: presentation. 
	presentation selection: 42. 
	self assert: (pane port: #selection) value = 42. 
	(pane port: #entity) value: 'foo'. 
	self assert: presentation entity = 'foo'! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 5/24/2010 17:23'!
testCopyAnnouncements

	| presentation newPresentation |
	presentation := GLMPresentation new.
	presentation when: GLMContextChanged do: [:ann | self fail ].
	self assert: (presentation instVarNamed: #subscriptions) size = 1.
	newPresentation := presentation copy.
	newPresentation announce: GLMContextChanged.
	self assert: (newPresentation instVarNamed: #subscriptions) isNil! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 1/11/2010 22:34'!
testCopyRootPrototype

	| presentation newPresentation yetAnotherPresentation |
	presentation := GLMPresentation new.
	newPresentation := presentation copy.
	self assert: newPresentation rootPrototype = presentation.
	self assert: newPresentation parentPrototype = presentation.
	yetAnotherPresentation := newPresentation copy.
	self assert: yetAnotherPresentation rootPrototype = presentation.
	self assert: yetAnotherPresentation parentPrototype = newPresentation! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 5/25/2010 23:09'!
testDefaultPane
	| presentation pane |
	presentation := GLMPresentation new.
	pane := presentation pane.
	self assert: pane presentations first pane == pane.
	self assert: pane presentations pane == pane.
	self assert: pane presentations first == presentation! !

!GLMPresentationTest methodsFor: 'tests' stamp: ' 4/5/09 22:18'!
testDisplay 
	 
	| presentation | 
	presentation := GLMPresentation new. 
	presentation entity: #foo. 
	self assert: presentation displayValue = #foo. 
	presentation entity: #(#foo #bar). 
	self assert: presentation displayValue = #(#foo #bar). 
	presentation entity: (GLMMultiValue withAll: #(#foo #bar)). 
	self assert: presentation displayValue = #foo. 
	presentation transformation: [:first :second | (first , second) asSymbol]. 
	self assert: presentation displayValue = #foobar! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 8/22/2010 15:46'!
testEquality
	| presentation |
	presentation := GLMPresentation new.
	self assert: (presentation = presentation copy) not! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 12/31/2009 00:24'!
testExplicitNotNilMultipleValues
	| presentation | 
	presentation := GLMPresentation new. 
	presentation useExplicitNotNil.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil nil)).
	self assert: presentation matches not.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(1 nil)).
	self assert: presentation matches.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)).
	self assert: presentation matches.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(1 2)).
	self assert: presentation matches.! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 1/13/2010 22:28'!
testHasTitle
	| presentation |
	presentation := GLMPresentation new.
	self assert: presentation hasTitle not.
	presentation title: 'something'.
	self assert: presentation hasTitle! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 1/13/2010 22:30'!
testHasTitleIcon
	| presentation |
	presentation := GLMPresentation new.
	self assert: presentation hasTitleIcon not.
	presentation titleIcon: 'something'.
	self assert: presentation hasTitleIcon! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 12/16/2009 17:49'!
testImplicitNotNilMultipleValues
	| presentation | 
	presentation := GLMPresentation new. 
	presentation useImplicitNotNil.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil nil)).
	self assert: presentation matches not.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(1 nil)).
	self assert: presentation matches not.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)).
	self assert: presentation matches not.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(1 2)).
	self assert: presentation matches.! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 12/31/2009 00:29'!
testMatching 
	 
	| presentation | 
	presentation := GLMPresentation new. 
	self assert: presentation usesImplicitNotNil. 
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)). 
	self assert: presentation matches not.
	(presentation pane port: #entity) value: 1. 
	self assert: presentation matches. 
	presentation useExplicitNotNil. 
	self assert: presentation usesImplicitNotNil not. 
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)). 
	self assert: presentation matches. 
	(presentation pane port: #entity) value: 1. 
	self assert: presentation matches. 
	presentation condition: [:x | x > 1]. 
	presentation useImplicitNotNil. 
	self assert: presentation usesImplicitNotNil. 
	(presentation pane port: #entity) value: nil. 
	self assert: presentation matches not. 
	(presentation pane port: #entity) value: 1. 
	self assert: presentation matches not. 
	(presentation pane port: #entity) value: 2. 
	self assert: presentation matches. 
	presentation useExplicitNotNil. 
	(presentation pane port: #entity) value: 1. 
	self assert: presentation matches not. 
	(presentation pane port: #entity) value: 2. 
	self assert: presentation matches. 
	self assert: presentation usesImplicitNotNil not. 
	[(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)). 
	presentation matches. 
	self signalFailure: 'Should have raised error'] 
		on: MessageNotUnderstood 
		do: 
			[:err |  
			self assert: err message selector = #>. 
			self assert: err message arguments = (Array with: 1)]! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 1/5/2010 21:08'!
testSetup
	| presentation |
	presentation := GLMPresentation new. 
	self assert: presentation pane notNil. 
	self assert: (presentation pane presentations includes: presentation)! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 1/14/2010 02:46'!
testTitle 
	 
	| presentation | 
	presentation := GLMPresentation new. 
	presentation entity: #foo. 
	self assert: presentation titleValue isNil.
	presentation title: '41'.
	self assert: presentation titleValue = '41'.
	presentation entity: '4'. 
	presentation title: [:x | x , '2']. 
	self assert: presentation titleValue = '42'. 
	presentation entity: (GLMMultiValue withAll: #('4' '3')). 
	presentation title: [:first :second | first , second]. 
	self assert: presentation titleValue = '43'! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 8/25/2009 16:01'!
testToSend
	| presentation |
	presentation := GLMPresentation new.
	presentation selection: #foo.
	self assert: presentation selection = #foo.
	presentation selection: #(#foo #bar ).
	self assert: presentation selection = #(#foo #bar ).
	presentation selection: (GLMMultiValue withAll: #(#foo #bar )).
	self assert: presentation selection = #foo.
	presentation selectionTransformation: [ :first :second | (first , second) asSymbol ].
	presentation selection: (GLMMultiValue withAll: #(#foo #bar )).
	self assert: presentation selection = #foobar! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 2/22/2010 11:05'!
testUnregisterAnnouncements
	| announcer presentation |
	announcer := Announcer new.
	presentation := GLMPresentation new.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	presentation registerAnnouncements.
	self assert: (announcer instVarNamed: 'subscriptions') size = 1.
	presentation unregisterFromAllAnnouncements.
	self assert: (announcer instVarNamed: 'subscriptions') isEmpty.
! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 14:37'!
testUnregisterAnnouncementsWhenEntityChanges
	| announcer1 presentation |
	announcer1 := Announcer new.
	presentation := GLMPresentation new.
	presentation updateOn: TestAnnouncement from: [ announcer1 ].
	presentation entity: 1.
	presentation registerAnnouncements.
	self assert: (announcer1 instVarNamed: 'subscriptions') size = 1.
	presentation entity: 2.
	self assert: (announcer1 instVarNamed: 'subscriptions') isEmpty.
	presentation registerAnnouncements.
	self assert: (announcer1 instVarNamed: 'subscriptions') size = 1.
	presentation entity: nil.
	self assert: (announcer1 instVarNamed: 'subscriptions') isEmpty.


	! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 14:03'!
testUpdate
	| col pane presentation |
	col := OrderedCollection with: 1 with: 2. 
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	pane addPresentation: presentation.
	presentation entity: col.
	presentation shouldValidate: true.
	presentation update.
	presentation selection: 2.
	self assert: presentation selection = 2.
	col removeLast.
	presentation update.
	self assert: presentation selection isNil
! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:54'!
testUpdateConditionallyTriggered 
	| pane presentation announcer timesTriggered |
	pane := GLMPane named: 'test'. 
	(pane port: #entity) value: 40.
	presentation := GLMPresentation new.
	announcer := Announcer new.
	pane addPresentation: presentation.
	timesTriggered := 0.
	presentation when: GLMPresentationUpdated do: [:announcement | 
		timesTriggered := timesTriggered + 1].

	presentation 
		updateOn: TestAnnouncement 
		from: [:x | announcer ]
		when: [ :ann :entity | ann parameter + entity = 42].
	presentation registerAnnouncements.
	
	announcer announce: (TestAnnouncement new parameter: 0).
	self assert: timesTriggered = 0.

	announcer announce: (TestAnnouncement new parameter: 2).
	self assert: timesTriggered = 1
! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 5/2/2010 23:38'!
testUpdateOnFromAllPortsUpdate
	| pane presentation announcers col updated |
	col := (1 to: 4) asOrderedCollection. 
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	announcers := col collect: [:each | Announcer new].
	pane addPresentation: presentation.
	presentation updateOn: TestAnnouncement fromAll: [ announcers ].
	presentation when: GLMPresentationUpdated do: [:a | updated := true ].
	presentation entity: col.
	presentation shouldValidate: true.
	presentation registerAnnouncements.

	updated := false.
	announcers last announce: TestAnnouncement.
	self assert: updated.
	updated := false.
	announcers last announce: TestAnnouncement.
	self assert: updated.
! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:54'!
testUpdateOnPortsUpdate
	| col pane presentation announcer |
	col := OrderedCollection with: 1 with: 2. 
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	announcer := Announcer new.
	pane addPresentation: presentation.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	presentation entity: col.
	presentation shouldValidate: true.
	presentation registerAnnouncements.
	presentation selection: 2.
	self assert: presentation selection = 2.
	col removeLast.
	announcer announce: TestAnnouncement.
	self assert: presentation selection isNil
! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:54'!
testUpdateOnTriggered
	| pane presentation announcer timesTriggered |
	pane := GLMPane named: 'test'. 
	presentation := GLMPresentation new.
	announcer := Announcer new.
	pane addPresentation: presentation.
	timesTriggered := 0.
	presentation when: GLMPresentationUpdated do: [:announcement | timesTriggered := timesTriggered + 1].

	presentation updateOn: TestAnnouncement from: #yourself.
	presentation entity: announcer.
	presentation registerAnnouncements.
	
	announcer announce: TestAnnouncement.
	self assert: timesTriggered = 1
! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 14:03'!
testValidate
	| pane presentation | 
	pane := GLMPane named: 'test'. 
	presentation := GLMPresentation new.
	pane addPresentation: presentation.
	presentation entity: (OrderedCollection with: 1 with: 2).
	self assert: (presentation validate: 1 on: (pane port: #foo)).
	self assert: (presentation validate: 2 on: (pane port: #foo)).
	self assert: (presentation validate: 5 on: (pane port: #foo))
! !

TestCase subclass: #GLMScriptingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testActionDefinition 
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one. 
	browser showOn: #one; using: [
		browser text act: [] entitled: ''.
		browser list act: [] entitled: ''.
		browser tree act: [] entitled: '']. 
	browser startOn: #(42).
	browser panes first presentations do: [:each | 
		self assert: each actions size = 1]! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 12/16/2009 21:36'!
testAllowNil
	| browser presentationsChanged matchingPresentationsChanged |
	browser := GLMTabulator new.
	browser 
		column: [: c | c row: #one; row: #two];
		column: #details.
	browser showOn: #one; using: [
		browser tree display: #(1 2 3)].
	browser showOn: #two; using: [
		browser tree display: #(a b c)].
	browser showOn: #details; from: #one; from: #two; using: [
		browser text 
			display: [ :one :two | one asString, two asString];
			allowNil ].
	browser startOn: 42.
	(browser paneNamed: #details) whenPresentationsChanged: [:a | presentationsChanged := true ].
	(browser paneNamed: #details) whenMatchingPresentationsChanged: [:a | matchingPresentationsChanged := true ].
	presentationsChanged := false.
	matchingPresentationsChanged := false.

	((browser paneNamed: #one) port: #selection) value: 2.
	self assert: presentationsChanged.
	self assert: matchingPresentationsChanged.
	self assert: ((browser paneNamed: #details) presentations first) displayValue = '2nil'.
	presentationsChanged := false.

	((browser paneNamed: #two) port: #selection) value: #c.
	self assert: presentationsChanged.
	self assert: matchingPresentationsChanged.
	self assert: ((browser paneNamed: #details) presentations first) displayValue = '2c'.
	presentationsChanged := false.

	((browser paneNamed: #one) port: #selection) value: nil.
	self assert: presentationsChanged.
	self assert: matchingPresentationsChanged.
	self assert: ((browser paneNamed: #details) presentations first) displayValue = 'nilc'.! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 1/5/2010 16:18'!
testConditionalPresentation 
	 
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one; column: #two. 
	browser showOn: #two; from: #one; using: [
		browser text when: [:x | x = 42]. 
		browser list when: [:x | x > 42]]. 
	((browser paneNamed: #one) port: #selection) value: 42. 
	self assert: (browser paneNamed: #two) matchingPresentations size = 1. 
	self assert: ((browser paneNamed: #two) matchingPresentations first isKindOf: 
					GLMTextPresentation). 
	((browser paneNamed: #one) port: #selection) value: 43. 
	self assert: (browser paneNamed: #two) matchingPresentations size = 1. 
	self assert: ((browser paneNamed: #two) matchingPresentations first isKindOf: 
					GLMListPresentation)! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testDynamicActions
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser
		showOn: #one;
		using: [ browser list
				display: [ :x | 1 to: x ];
				actions: [ :list | 
					(1 to: list selection) collect: 
						[ :index | 
						GLMAction new
							action: [ index ];
							title: 'Action' , index printString;
							yourself ] ] ].
	browser startOn: 42.
	(browser panes first port: #selection) value: 3.
	self assert: browser panes first presentations first dynamicActions size = 3.
	(browser panes first port: #selection) value: 5.
	self assert: browser panes first presentations first dynamicActions size = 5! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 2/21/2010 01:22'!
testEntityInUpdateAction 
	 
	| browser inputFromActionBlock | 
	browser := GLMTabulator new. 
	browser column: #one. 
	browser 
		showOn: #one; 
		using: 
				[browser text 
						populate: #foo 
						on: $m 
						with: [:list :input | inputFromActionBlock := input]]. 
	browser startOn: 42. 
	browser panes first presentations first actions first 
		actOn: browser panes first presentations first. 
	self assert: inputFromActionBlock = 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:43'!
testFinderWithPreviousPort
	| browser | 
	browser := GLMFinder new. 
	browser list
		title: 'Presentation1'; 
		display: [:each | 1 to: each]. 
	browser 
		fromPrevious: #selection; 
		passivelyFromPrevious: #highlight; 
		using: [
			browser list
				title: 'Presentation2'; 
				display: [:selection :highlight | 1 to: (selection + highlight) ]]. 
	browser startOn: 42. 
	self assert: browser presentations size = 1. 
	self assert: browser presentations first title = 'Presentation1'. 
	self assert: browser transmissions size = 1. 
	self assert: browser transmissions last origins size = 2. 
	self assert: browser transmissions last transmissionStrategy presentations size = 1. 
	self assert: browser transmissions last transmissionStrategy presentations first title = 'Presentation2'. 
	self assert: (browser panes first port: #entity) value = 42. 
	(browser panes first port: #highlight) value: 43. 
	(browser panes first port: #selection) value: 41. 
	self assert: browser panes size = 2. 
	self assert: browser panes last presentations size = 2.
	self assert: browser panes last presentations last displayValue size = 84. 
	self assert: browser panes last presentations size = 2! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 1/12/2010 14:21'!
testNestedBrowserEntity
	 
	| browser innerBrowser realInnerBrowser | 
	browser := GLMTabulator new. 
	browser column: #one. 
	innerBrowser := GLMTabulator new. 
	innerBrowser column: #innerOne. 
	innerBrowser 
		showOn: #innerOne;
		from: #outer->#entity;
		using: [innerBrowser text]. 
	browser 
		showOn: #one; 
		using: [
			(browser custom: innerBrowser)
				display: [:x | x + 2 ]]. 
	browser startOn: 40. 
	realInnerBrowser := (browser paneNamed: #one) presentations first.
	self assert: ((browser paneNamed: #one) port: #entity) value = 40. 
	self assert: (realInnerBrowser pane port: #entity) value = 40.
	self assert: ((realInnerBrowser paneNamed: #innerOne) port: #entity) value = 42.! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 1/12/2010 14:22'!
testNestedBrowserOther
	 
	| browser innerBrowser realInnerBrowser | 
	browser := GLMTabulator new.
	browser column: #one; column: #two. 
	innerBrowser := GLMTabulator new. 
	innerBrowser column: #innerOne. 
	innerBrowser 
		showOn: #innerOne;
"		from: #outer->#entity;"
		using: [innerBrowser text].
	innerBrowser sendToOutside: #selection from: #innerOne.
	browser showOn: #one; using: [
		(browser custom: innerBrowser)
			display: [:x | x + 2 ]]. 
	browser showOn: #two; from: #one; using: [browser text].
	browser startOn: 40. 
	realInnerBrowser := (browser paneNamed: #one) presentations first.
	self assert: ((browser paneNamed: #one) port: #entity) value = 40. 
	self assert: (realInnerBrowser pane port: #entity) value = 40.
	self assert: ((realInnerBrowser paneNamed: #innerOne) port: #entity) value = 42.
	(realInnerBrowser panes first port: #selection) value: 7.
	self assert: (realInnerBrowser pane port: #selection) value = 7.
	self assert: (browser panes last port: #entity) value = 7.! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 1/12/2010 14:22'!
testNestedBrowserWithExplicitTransmission 
	 
	| browser innerBrowser realInnerBrowser | 
	browser := GLMTabulator new. 
	browser column: #one. 
	innerBrowser := GLMTabulator new. 
	innerBrowser column: #innerOne. 
	innerBrowser 
		showOn: #innerOne; 
		from: #outer -> #entity; 
		using: [innerBrowser text]. 
	browser 
		showOn: #one; 
		using: [browser custom: innerBrowser]. 
	browser startOn: 42. 
	realInnerBrowser := (browser paneNamed: #one) presentations first.
	self assert: ((browser paneNamed: #one) port: #entity) value = 42. 
	self assert: ((realInnerBrowser paneNamed: #innerOne) port: #entity) value = 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'lr 6/4/2010 14:04'!
testOuterEntity 
	| browser | 
	browser := GLMTabulator new.
	browser column: #one; column: #two. 
	browser showOn: #one; using: [browser text]. 
	browser showOn: #two; fromOutside: #entity; using: [browser text].
	browser startOn: 42.
	self assert: browser transmissions first origins anyOne name = #entity.
	self assert: browser transmissions last origins anyOne name = #entity.
	self assert: browser transmissions size = 2.
	! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testPublishing 
	 
	| browser | 
	browser := GLMTabulator new. 
	browser column: #classes. 
	browser 
		sendToOutside: #selectedClass 
		from: #classes -> #selection. 
	browser 
		sendTo: #classes -> #highlight 
		fromOutside: #highlightedClass. 
	(browser panes first port: #selection) value: 42. 
	self assert: (browser pane port: #selectedClass) value = 42. 
	self assert: (browser panes first port: #selection) value = 42. 
	(browser pane port: #highlightedClass) value: 43. 
	self assert: (browser pane port: #highlightedClass) value = 43. 
	self assert: (browser panes first port: #highlight) value = 43. 
	(browser panes first port: #highlight) value: 44. 
	self assert: (browser pane port: #highlightedClass) value = 43. 
	self assert: (browser panes first port: #highlight) value = 44. 
	(browser pane port: #selectedClass) value: 45. 
	self assert: (browser pane port: #selectedClass) value = 45. 
	self assert: (browser panes first port: #selection) value = 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 1/13/2010 17:10'!
testPublishingToOutsideAndInsideFinder
	| innerBrowser finder realInnerBrowser | 
	finder := GLMFinder new.
	innerBrowser := GLMTabulator new.
	innerBrowser column: #one; column: #two.
	innerBrowser showOn: #one; using: [ innerBrowser list display: [:x | 1 to: 43 ] ].
	innerBrowser showOn: #two; from: #one; using: [ innerBrowser text ].
	innerBrowser sendToOutside: #selection from: #one -> #selection.
	finder custom: innerBrowser.
	
	self assert: (innerBrowser transmissions size = 3).
	self assert: (innerBrowser transmissions second origins first pane == innerBrowser panes first).
	self assert: (innerBrowser transmissions second destination pane == innerBrowser panes last).

	finder startOn: 43.

	realInnerBrowser := innerBrowser.
	self assert: (realInnerBrowser transmissions size = 3).
	self assert: (realInnerBrowser transmissions second origins first pane == realInnerBrowser panes first).
	self assert: (realInnerBrowser transmissions second destination pane == realInnerBrowser panes last).! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 1/12/2010 14:51'!
testPublishingToOutsideFinder
	| innerBrowser finder | 
	finder := GLMFinder new.
	innerBrowser := GLMTabulator new.
	innerBrowser column: #any.
	innerBrowser showOn: #any; using: [ innerBrowser list display: [:x | 1 to: 43 ] ].
	innerBrowser
		sendToOutside: #selection
		from: #any -> #selection.
	finder custom: innerBrowser.
	finder startOn: 43.
	self assert: (finder panes first port: #entity) value = 43.
	self assert: (finder panes first port: #selection) value isNil.
	((finder panes first presentations first paneNamed: #any) port: #selection) value: 42.
	self assert: (finder panes first port: #selection) value = 42.
	self assert: (finder panes first port: #entity) value = 43.
	self assert: finder panes size = 2.
	self assert: (finder panes last port: #entity) value = 42.
	
	self assert: (finder panes first presentations first isKindOf: GLMTabulator).
	self assert: (finder panes last presentations first isKindOf: GLMTabulator).
	self assert: (finder panes first presentations first isKindOf: GLMTabulator).
	! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 1/5/2010 22:03'!
testReferences
	| browser pane1 | 
	browser := GLMExplicitBrowser new.  
 	pane1 := browser addNewPaneNamed: #pane1.
	self assert: (browser resolveOriginPort: #pane1) == (pane1 port: #selection). 
	self assert: (browser resolveOriginPort: #pane1 -> #foo) == (pane1 port: #foo). 
	self assert: (browser resolveDestinationPort: #pane1) == (pane1 port: #entity). 
	self assert: (browser resolveDestinationPort: #pane1 -> #foo) == (pane1 port: #foo). 
	self assert: ((browser resolveOriginPort: #outer) isKindOf: GLMPresentationBoundPort). 
	self assert: (browser resolveOriginPort: #outer) presentation == browser. 
	self assert: (browser resolveOriginPort: #outer) name = #selection. 
	self assert: ((browser resolveOriginPort: #outer -> #foo) isKindOf: GLMPresentationBoundPort). 
	self assert: (browser resolveOriginPort: #outer -> #foo) presentation == browser. 
	self assert: (browser resolveOriginPort: #outer -> #foo) name = #foo. 
	self assert: ((browser resolveDestinationPort: #outer) isKindOf: GLMPresentationBoundPort). 
	self assert: (browser resolveDestinationPort: #outer) presentation == browser. 
	self assert: (browser resolveDestinationPort: #outer) name = #entity. 
	self assert: ((browser resolveDestinationPort: #outer -> #foo) isKindOf: GLMPresentationBoundPort). 
	self assert: (browser resolveDestinationPort: #outer -> #foo) presentation == browser. 
	self assert: (browser resolveDestinationPort: #outer -> #foo) name = #foo! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TestRunner 11/20/2009 01:03'!
testScriptingDefaults 
	 
	| browser | 
	browser := GLMTabulator new. 
	browser startOn: 42. 
	self assert: browser panes size = 1. 
	self assert: browser transmissions size = 1.
	self assert: browser transmissions first origins first
				= (browser pane port: #entity).
	self assert: browser transmissions first destination 
				= (browser panes first port: #entity)! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 2/20/2010 14:07'!
testSimpleTransmission 
	| browser | 
	browser := GLMTabulator new. 
	browser 
		column: #one; 
		column: #two. 
	browser 
		sendTo: #two -> #port2 
		from: #one -> #port1. 
	self assert: browser transmissions size = 1. 
	self assert: (browser transmissions first transmissionStrategy isKindOf: GLMNoStrategy). 
	self assert: 
			browser transmissions first origins first
				= ((browser paneNamed: #one) port: #port1). 
	self 
		assert: 
			browser transmissions first destination 
				= ((browser paneNamed: #two) port: #port2)! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 12/29/2009 16:49'!
testSimpleTransmissionsToOuter
	 
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one. 
	browser sendTo: #outer->#increased from: #outer->#entity with: [ :x | x + 1 ].
	browser showOn: #one; from: #outer->#increased; using: [browser text].
	browser startOn: 41.
	self assert: ((browser paneNamed: #one) port: #entity) value = 42
! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TestRunner 11/20/2009 00:51'!
testStartTransmission 
	 
	| browser | 
	browser := GLMTabulator new. 
	browser 
		column: #one; 
		column: #two. 
	browser 
		showOn: #one; 
		using: [browser list]. 
	self assert: browser transmissions size = 1.
	self assert: (browser paneNamed: #one) presentations isEmpty. 
	self assert: (browser paneNamed: #two) presentations isEmpty. 
	browser startOn: 15. 
	self assert: (browser paneNamed: #one) presentations size = 1. 
	self assert: (browser paneNamed: #two) presentations isEmpty! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TestRunner 11/20/2009 00:51'!
testStartWithOnlyJumpStart 
	 
	| browser | 
	browser := GLMTabulator new. 
	browser 
		column: #one; 
		column: #two. 
	browser 
		showOn: #one; 
		using: [browser list]. 
	browser 
		showOn: #two; 
		from: #one; 
		using: [browser text]. 
	self assert: browser transmissions size = 2.
	self assert: (browser paneNamed: #one) presentations isEmpty. 
	self assert: (browser paneNamed: #two) presentations isEmpty. 
	browser startOn: #(15 25 35). 
	self assert: (browser paneNamed: #one) presentations size = 1. 
	self assert: (browser paneNamed: #one) matchingPresentations size = 1. 
	self assert: (browser paneNamed: #two) presentations isEmpty. 
	self assert: (browser paneNamed: #two) matchingPresentations isEmpty! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'lr 6/4/2010 14:37'!
testThreePanesTransmissions 
	| browser two |
	browser := GLMTabulator new. 
	browser 
		column: #one; 
		column: #two; 
		column: #three. 
	browser transmit
		to: #three; 
		from: #one; 
		passivelyFrom: #two; 
		andShow: [:a | 
			a text 
						display: 
							[:x :y |  
							two := y]]. 
	self assert: browser transmissions size = 1. 
	self assert: browser transmissions first passiveOrigins size = 1. 
	self assert: browser transmissions first activeOrigins size = 1. 
	((browser paneNamed: #two) port: #selection) value: 15. 
	self assert: ((browser paneNamed: #two) port: #selection) value = 15. 
	self assert: ((browser paneNamed: #three) port: #entity) value isNil. 
	((browser paneNamed: #one) port: #selection) value: 20. 
	self assert: ((browser paneNamed: #one) port: #selection) value = 20. 
	self assert: ((browser paneNamed: #three) port: #entity) value first = 20. 
	self assert: ((browser paneNamed: #three) port: #entity) value last = 15! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testTransmissionWithTwoOrigins 
	 
	| browser | 
	browser := GLMTabulator new. 
	browser 
		column: #one; 
		column: #two; 
		column: #three. 
	browser 
		showOn: #three; 
		from: #one; 
		from: #two; 
		using: [browser text]. 
	((browser paneNamed: #one) port: #selection) value: 42. 
	self assert: ((browser paneNamed: #three) port: #entity) value first = 42. 
	self assert: ((browser paneNamed: #three) port: #entity) value last = nil. 
	self assert: (browser paneNamed: #three) presentations size = 1. 
	self assert: (browser paneNamed: #three) matchingPresentations size = 0. 
	((browser paneNamed: #two) port: #selection) value: 43. 
	self assert: ((browser paneNamed: #three) port: #entity) value first = 42. 
	self assert: ((browser paneNamed: #three) port: #entity) value last = 43. 
	self assert: (browser paneNamed: #three) matchingPresentations size = 1! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 11/20/2009 01:09'!
testTwoTransmissionsWithOnlyOneEvent 
	 
	| browser | 
	browser := GLMTabulator new. 
	browser 
		column: #one; 
		column: #two; 
		column: #three. 
	browser 
		showOn: #two; 
		from: #one; 
		using: [browser list]. 
	browser 
		showOn: #three; 
		from: #two; 
		using: [browser text]. 
	self assert: browser transmissions size = 2. 
	self assert: (browser paneNamed: #one) presentations isEmpty. 
	self assert: (browser paneNamed: #two) presentations isEmpty. 
	self assert: (browser paneNamed: #three) presentations isEmpty. 
	((browser paneNamed: #one) port: #selection) value: 42. 
	self assert: ((browser paneNamed: #two) port: #entity) value = 42. 
	self assert: (browser paneNamed: #one) presentations isEmpty. 
	self assert: (browser paneNamed: #two) presentations size = 1. 
	self assert: (browser paneNamed: #two) matchingPresentations size = 1. 
	self assert: (browser paneNamed: #three) presentations isEmpty. 
	self assert: (browser paneNamed: #three) matchingPresentations isEmpty! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 2/21/2010 01:22'!
testUpdateAction 
	 
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one; column: #two. 
	browser showOn: #one; using: [
		browser list populate: #foo on: $m with: [:list :input | 42]]. 
	browser showOn: #two; from: #one -> #foo; using: [browser text]. 
	browser startOn: #(1 2 3). 
	self assert: browser panes first presentations size = 1. 
	self assert: browser panes last presentations isEmpty. 
	browser panes first presentations first actions first 
		actOn: browser panes first presentations first. 
	self assert: browser panes second presentations size = 1. 
	self assert: browser panes second presentations first entity = 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'tg 2/22/2010 11:05'!
testUpdateYourselfOn

	| announcer entity browser presentation |
	announcer := Announcer new.
	entity := OrderedCollection with: 1 with: 2 with: 3.
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		presentation := browser list 
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true ].
	browser startOn: entity.
	presentation registerAnnouncements.
	presentation selection: 3.
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: presentation selection isNil ! !

TestCase subclass: #GLMTabulatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMTabulatorTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testComplex 
	 
	| layout | 
	layout := GLMTabulator new. 
	layout 
		addColumn: 
			[:column |  
			column addRow: #second. 
			column addRow: #third. 
			column addRow: #fourth. 
			column 
				addRow: 
					[:row |  
					row addColumn: #fifth. 
					row addColumn: #sixth]]. 
	layout addColumn: #first. 
	self assert: layout cell children size = 2. 
	self assert: layout cell children first children size = 4. 
	self assert: layout cell children first children last children size = 2! !

!GLMTabulatorTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testOneSimpleColumnAndOneNested 
	 
	| layout | 
	layout := GLMTabulator new. 
	layout 
		addColumn: 
			[:column |  
			column addRow: #second. 
			column addRow: #third. 
			column addRow: #fourth]. 
	layout addColumn: #first. 
	self assert: layout cell children size = 2. 
	self assert: layout cell children first children size = 3! !

!GLMTabulatorTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testOneSimpleRowAndOneNested 
	 
	| layout | 
	layout := GLMTabulator new. 
	layout addRow: #first. 
	layout 
		addRow: 
			[:row |  
			row addColumn: #second. 
			row addColumn: #third. 
			row addColumn: #fourth]. 
	self assert: layout cell children size = 2. 
	self assert: layout cell children last children size = 3! !

!GLMTabulatorTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testSimpleColumns 
	 
	| layout | 
	layout := GLMTabulator new. 
	layout addColumn: #first. 
	layout addColumn: #second. 
	self assert: layout cell children size = 2! !

!GLMTabulatorTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testSimpleRows 
	 
	| layout | 
	layout := GLMTabulator new. 
	layout addRow: #first. 
	layout addRow: #second. 
	self assert: layout cell children size = 2. 
	self assert: layout cell isColumn. 
	self assert: layout cell children first isRow! !

TestCase subclass: #GLMTextPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMTextPresentationTest methodsFor: 'testing' stamp: 'tg 8/7/2009 01:25'!
testSelectedText
	| presentation |
	presentation := GLMTextPresentation new.
	self assert: (presentation selectedText = '').
	presentation selectedTextBlock: ['selection'].
	self assert: (presentation selectedText = 'selection')! !

TestCase subclass: #GLMTransmissionContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMTransmissionContextTest methodsFor: 'testing' stamp: 'tg 12/19/2009 00:06'!
testCopy
	| context copy |
	context := GLMTransmissionContext new.
	context addPort: GLMSimplePort new.
	copy := context copy.
	self assert: copy ~~ context.
	self assert: copy ports = context ports.
	self assert: copy ports ~~ context ports.
! !

!GLMTransmissionContextTest methodsFor: 'testing' stamp: 'tg 12/19/2009 00:26'!
testForbiddenAnnouncements
	| context pane |
	context := GLMTransmissionContext new.
	pane := GLMPane new.
	self assert: (context canAnnounceMatchingPresentationsChanged: pane).
	context forbidToAnnounceMatchingPresentationsChanged: pane.
	self assert: (context canAnnounceMatchingPresentationsChanged: pane) not! !

!GLMTransmissionContextTest methodsFor: 'testing' stamp: 'tg 12/19/2009 00:07'!
testInclues
	| context port |
	port := GLMSimplePort new.
	context := GLMTransmissionContext new.
	context addPort: port.
	self assert: (context includesPort: port)! !

TestCase subclass: #GLMTransmissionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 8/22/2010 16:39'!
testBundleStrategy
	| pane1 pane2 transmission presentation |
	pane1 := GLMPane named: 'pane1'.
	pane2 := GLMPane named: 'pane2'.
	transmission := GLMTransmission new.
	transmission "ensureNoOverrideBundleStrategy" ensureBundleStrategy.
	transmission addActiveOrigin: (pane1 port: #port1). 
	transmission destination: (pane2 port: #port2). 
	transmission addPresentation: GLMPresentation new.
	(pane1 port: #port1) value: 1.
	transmission transmit.
	self assert: pane2 presentations size = 1.
	presentation := pane2 presentations first.
	(pane1 port: #port1) value: 2.
	transmission transmit.
	self assert: pane2 presentations first rootPrototype = presentation rootPrototype.
	self assert: pane2 presentations first ~~ presentation! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 1/14/2010 15:58'!
testCopy
	| transmission port1 port2 newTransmission |
	transmission := GLMTransmission new.
	port1 := GLMSimplePort new.
	port2 := GLMSimplePort new.
	transmission destination: port2.
	transmission addActiveOrigin: port1.
	newTransmission := transmission copy.
	self assert: newTransmission destination == transmission destination.
	self assert: newTransmission origins first == transmission origins first.! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 2/20/2010 14:07'!
testDefaultStrategy
	self assert: GLMTransmission new transmissionStrategy class = GLMNoStrategy! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 8/22/2010 16:42'!
testNoOverrideStrategy
	| pane1 pane2 transmission presentation |
	pane1 := GLMPane named: 'pane1'.
	pane2 := GLMPane named: 'pane2'.
	transmission := GLMTransmission new.
	transmission ensureNoOverrideBundleStrategy.
	transmission addActiveOrigin: (pane1 port: #port1). 
	transmission destination: (pane2 port: #port2). 
	transmission addPresentation: GLMPresentation new.
	self assert: transmission presentations size = 1.
	self assert: transmission destination pane == pane2.
	self assert: transmission transmissionStrategy transmission == transmission.
	(pane1 port: #port1) value: 1.
	transmission transmit.
	self assert: pane2 presentations size = 1.
	presentation := pane2 presentations first.
	self assert: transmission destination pane == pane2.
	(pane1 port: #port1) value: 2.
	transmission transmit.
	self assert: pane2 presentations first rootPrototype = presentation rootPrototype.
	self assert: pane2 presentations first == presentation! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 1/14/2010 15:58'!
testSimple 
	| pane1 pane2 transmission | 
	pane1 := GLMPane named: 'test1'. 
	pane2 := GLMPane named: 'test2'. 
	transmission := (GLMTransmission new) 
		addActiveOrigin: (pane1 port: #output); 
		destination: (pane2 port: #input); 
		yourself. 
	(pane1 port: #output) value: 42. 
	self assert: (pane1 port: #output) value = 42. 
	self assert: (pane2 port: #input) value = nil. 
	transmission transmit. 
	self assert: (pane1 port: #output) value = 42. 
	self assert: (pane2 port: #input) value = 42! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 1/31/2010 01:40'!
testTriggerConditions 
	"Tests that the transmission is triggered only when the origin changes." 
	
	| transmission port1 port2 | 
	transmission := GLMTransmission new. 
	port1 := GLMSimplePort new name: #port1. 
	port2 := GLMSimplePort new name: #port2. 
	transmission addActiveOrigin: port1. 
	transmission destination: port2. 
	self assert: (transmission originatesAt: port1). 
	self assert: (transmission originatesAt: port2) not. 
	self assert: (transmission originatesAt: GLMPort new) not! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 1/17/2010 16:15'!
testTriggerConditionsWithParentPort 
	| transmission presentation | 
	transmission := GLMTransmission new. 
	presentation := GLMPresentation new. 
	transmission addActiveOrigin: 
			((GLMPresentationBoundPort new) 
				presentation: presentation; 
				name: #port1; 
				yourself). 
	self assert: (transmission originatesAt: 
					((GLMPresentationBoundPort new) 
						presentation: presentation; 
						name: #port1; 
						yourself)). 
	self assert: (transmission originatesAt: (presentation pane port: #port1))! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 1/31/2010 01:38'!
testWhenCondition
	"Tests that the transmission is triggered only when the origin changes." 
	
	| transmission port1 port2 | 
	transmission := GLMTransmission new. 
	port1 := GLMSimplePort new name: #port1; value: #value1. 
	port2 := GLMSimplePort new name: #port2. 
	transmission addActiveOrigin: port1. 
	transmission destination: port2. 
	transmission condition: [ :entity | entity = #value1 ].
	
	self assert: transmission meetsCondition.
	
	transmission transmit.
	
	self assert: port2 value = #value1.! !

TestCase subclass: #GLMTreePresentationTest
	instanceVariableNames: 'pane presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GLMTreePresentationTest methodsFor: 'tests' stamp: 'tg 11/15/2009 23:53'!
setUp
	pane := GLMPane named: 'test'.
	presentation := GLMTreePresentation new.
	pane addPresentation: presentation.
	presentation entity: #(($a $b $c $d) ($e $f) ($g)).
	presentation children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new]].
	presentation shouldValidate: true.! !

!GLMTreePresentationTest methodsFor: 'tests' stamp: 'tg 11/15/2009 17:06'!
testValidateOn
	self assert: (presentation validate: #($e $f) on: (pane port: #selection)).
	self assert: (presentation validate: $a on: (pane port: #selection)).
	self deny: (presentation validate: $h on: (pane port: #selection))! !

!GLMTreePresentationTest methodsFor: 'tests' stamp: 'tg 11/15/2009 17:06'!
testValidatePorts
	presentation selection: #($e $f).
	self assert: presentation selection = #($e $f).
	presentation selection: $a.
	self assert: presentation selection = $a.
	presentation selection: 'wrongSelection'."this should be invalid"
	self assert: presentation selection = $a! !

Object subclass: #GlamourousBenchmark
	instanceVariableNames: 'progressBarSize progress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GlamourousBenchmark methodsFor: 'as yet unclassified' stamp: 'tg 1/23/2010 00:54'!
defaultBrowser 
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.

	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x * 3] ].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 3] ].
	browser showOn: #one; from: #two; using: [
		browser list
			display: [:x | 1 to: x * 3] ].

	^ browser! !

!GlamourousBenchmark methodsFor: 'as yet unclassified' stamp: 'tg 1/22/2010 21:31'!
defaultFinderBrowser 
	"
	self new defaultFinderBrowser openOn: 10
	"
	| finder |
	finder := GLMFinder new.
	finder list
		title: 'title';
		display: [:each | 1 to: each ];
		showOnly: 50.

	^ finder! !

!GlamourousBenchmark methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 10/23/2009 09:50'!
measureOpeningTime
	| browser numberOfOpenings time |
	numberOfOpenings := 15.

	browser := self defaultBrowser.
	time := Time millisecondsToRun: [ numberOfOpenings timesRepeat: [(browser openOn: 10) delete] ].
	^ {numberOfOpenings . time}! !

!GlamourousBenchmark methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 10/23/2009 09:57'!
measureSelectionTime
	"
	self new measureSelectionTime 
	"
	^ self measureSelectionTimeForSize: 1000! !

!GlamourousBenchmark methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 10/23/2009 10:04'!
measureSelectionTimeForSize: size
	"
	self new measureSelectionTime 
	"
	| browser numberOfSelections time port window |
	numberOfSelections := 15.

	browser := self defaultBrowser.
	window := browser openOn: size.
	port := browser panes first ports second.
	time := Time millisecondsToRun: [ (size - numberOfSelections) to: size do: [:i | port value: i ] ].
	window delete.
	^ {size . time}! !

!GlamourousBenchmark methodsFor: 'as yet unclassified' stamp: 'lr 6/4/2010 14:50'!
measureSelectionTimeInFinderForSize: size
	"
	self new measureSelectionTimeInFinderForSize: 20 
	"
	| browser time window |

	browser := self defaultFinderBrowser.
	window := browser openOn: size.
	
	time := Time millisecondsToRun: 
			[size timesRepeat: [ (window model panes last port: #selection) value: size].].
		
	window delete.
	^ {size . time}! !

!GlamourousBenchmark methodsFor: 'as yet unclassified' stamp: 'tg 1/23/2010 00:54'!
showOnlyBrowser 
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.

	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x * 3];
			showOnly: 50].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 3];
			showOnly: 50].
	browser showOn: #one; from: #two; using: [
		browser list
			display: [:x | 1 to: x * 3];
			showOnly: 50].

	^ browser! !

!GlamourousBenchmark methodsFor: 'as yet unclassified' stamp: 'tg 1/23/2010 00:54'!
showOnlyFinderBrowser 
	"
	self new showOnlyFinderBrowser openOn: 10
	"
	| finder |
	finder := GLMFinder new.
	finder list
		title: 'title';
		display: [:each | 1 to: each ];
		showOnly: 50.

	^ finder! !

Object subclass: #GlamourousHealth
	instanceVariableNames: 'progressBarSize progress progressBarCurrentValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests'!

!GlamourousHealth classSide methodsFor: 'as yet unclassified' stamp: 'Alexandre Bergel 10/23/2009 09:03'!
produceReport
	^ self new produceReport! !

!GlamourousHealth methodsFor: 'progress bar' stamp: 'Alexandre Bergel 10/23/2009 11:32'!
displayProgressBar: aBlock size: size titled: title

	progressBarCurrentValue := 1.
	title
		displayProgressAt: Display center
		from: 0 to: size
		during: [:bar | aBlock value: bar ]
! !

!GlamourousHealth methodsFor: 'progress bar' stamp: 'Alexandre Bergel 10/23/2009 11:32'!
incrProgressBar: bar
	progressBarCurrentValue :=  progressBarCurrentValue + 1.
	bar value: progressBarCurrentValue.
! !

!GlamourousHealth methodsFor: 'logging' stamp: 'Alexandre Bergel 10/23/2009 09:01'!
log: object named: title
	| selectorName source newSource |
	selectorName := (#log, title) asSymbol.
	(self class includesSelector: selectorName)
		ifFalse: [ self class compile: selectorName, String cr, String cr, '	^ #()', String cr.
					  self class organization classify: selectorName under: 'logging'].

	source := (self class >> selectorName) getSourceFromFile.
	newSource := source , '	,#(#(', object printString, ' ''', title, '''))'.
	self class compile: newSource.! !

!GlamourousHealth methodsFor: 'logging' stamp: 'AlexandreBergel 10/26/2009 17:39'!
logMethodCoverage

	^ #()
	,#(#(0 'MethodCoverage'))	,#(#(86.0 'MethodCoverage'))	,#(#(86.0 'MethodCoverage'))	,#(#(84.31 'MethodCoverage'))	,#(#(84.31 'MethodCoverage'))	,#(#(84.31 'MethodCoverage'))	,#(#(83.49 'MethodCoverage'))	,#(#(83.49 'MethodCoverage'))	,#(#(83.49 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(77.47 'MethodCoverage'))	,#(#(76.78 'MethodCoverage'))	,#(#(76.78 'MethodCoverage'))	,#(#(76.78 'MethodCoverage'))	,#(#(76.99 'MethodCoverage'))	,#(#(76.99 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(0.0 'MethodCoverage'))	,#(#(0.0 'MethodCoverage'))	,#(#(33.07 'MethodCoverage'))	,#(#(33.02 'MethodCoverage'))	,#(#(33.02 'MethodCoverage'))	,#(#(32.98 'MethodCoverage'))	,#(#(32.98 'MethodCoverage'))	,#(#(33.46 'MethodCoverage'))	,#(#(33.46 'MethodCoverage'))! !

!GlamourousHealth methodsFor: 'util' stamp: 'Alexandre Bergel 10/23/2009 10:35'!
openMondrianGraphOn: associations titled: titleAsString

	^ self openMondrianGraphOn: associations titled: titleAsString scaleX: 0.10! !

!GlamourousHealth methodsFor: 'util' stamp: 'Alexandre Bergel 10/23/2009 10:35'!
openMondrianGraphOn: associations titled: titleAsString scaleX: scaleXFactor

	| view |
	view := MOViewRenderer new.


	view node: #foo forIt: [
		view layout: (MOScatterplotLayout new x: #key; y: #value; scaleFactorX: scaleXFactor; scaleFactorY: 0.10 "; upSideDown").
		view interaction popupText: [:element | element key printString, ' nodes => ', element value printString, ' ms' ].
		view nodes: associations.
	
	].
	view open! !

!GlamourousHealth methodsFor: 'util' stamp: 'Alexandre Bergel 10/23/2009 09:03'!
openWorkspaceWith: stream
	Workspace new contents: (stream contents); openLabel: 'Glamour health report'.! !

!GlamourousHealth methodsFor: 'public' stamp: 'Alexandre Bergel 10/23/2009 12:46'!
produceReport
	"
	self new produceReport
	"
	| stream |
	stream := WriteStream on: String new.
	self writeGeneralInfoOn: stream.
	self writeOpeningMeasurementsOn: stream.
	self writeSelectionMeasurementsOn: stream.
	self writeSelectionInFinderMeasurementsOn: stream.
	self writeCoverageInfoOn: stream.
	
	self openWorkspaceWith: stream.
! !

!GlamourousHealth methodsFor: 'public' stamp: 'lr 6/4/2010 14:04'!
viewTestCoverage
	"
	GlamourousHealth new viewTestCoverage
	"
	| typeClass coverage |
	typeClass := Smalltalk 
		at: #CoveragePackageSpy
		ifAbsent: 
			[ self inform: 'The coverage is realized by the tool Spy. Please download it from www.squeaksource.com/Spy.html . Skip the coverage by pressing OK'.
			^ self ].
	coverage := typeClass forPackagesMatching: 'Glamour*'.
	coverage viewBasic! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'lr 6/4/2010 14:04'!
writeCoverageInfoOn: stream 
	| typeClass ratioCoveredMethods lastCoverage diff diffAsString |
	typeClass := Smalltalk 
		at: #CoveragePackageSpy
		ifAbsent: 
			[ self inform: 'The coverage is realized by the tool Spy. Please download it from www.squeaksource.com/Spy.html . Skip the coverage by pressing OK'.
			^ self ].
	self 
		displayProgressBar: 
			[ :bar | 
			ratioCoveredMethods := (typeClass 
				forPackagesMatching: 'Glamour*'
				atEachTestEvaluate: [ self incrProgressBar: bar ]) ratioCoveredMethods ]
		size: (typeClass numberOfTestUnitClassesInPackagesMatching: 'Glamour*')
		titled: 'Running test for coverage'.
	stream
		nextPutAll: ratioCoveredMethods printString , '  % of methods are covered';
		cr.
	lastCoverage := self logMethodCoverage last first.
	diff := ratioCoveredMethods - lastCoverage.
	diff := ((diff * 100) asInteger / 100) asFloat.
	diffAsString := diff > 0 
		ifTrue: [ '+' , diff printString ]
		ifFalse: [ diff printString ].
	stream nextPutAll: 'Progress from last time: ' , diffAsString , ' %'.
	stream cr.
	self 
		log: ratioCoveredMethods
		named: 'MethodCoverage'! !

!GlamourousHealth methodsFor: 'util' stamp: 'Alexandre Bergel 10/23/2009 09:44'!
writeDelimitationOn: stream
	stream nextPutAll: '------------------'; cr! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'lr 6/4/2010 14:04'!
writeGeneralInfoOn: stream
	stream nextPutAll: 'Report produced on ', DateAndTime now printString; cr.
	MCWorkingCopy allManagers detect: [:m | m package name beginsWith: 'Glamour-Tests' ].! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'Alexandre Bergel 10/23/2009 11:37'!
writeOpeningMeasurementsOn: stream
	| res |
	self writeDelimitationOn: stream.
	stream nextPutAll: 'Opening Browser Benchmark:'; cr.

	self displayProgressBar: [:bar | 
		res := GlamourousBenchmark new measureOpeningTime.
		stream nextPutAll: res first printString, ' openings => ', res second printString, ' ms'; cr.
		self incrProgressBar: bar.
		]
		size: 1
		titled: 'Opening'.
	
	self writeDelimitationOn: stream.
	stream cr.! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'AlexandreBergel 10/26/2009 17:38'!
writeSelectionInFinderMeasurementsOn: stream
	| res browserSizes bench associations title |
	browserSizes := #(1 5 10 15 20 25 30 35 40 45 50).
	self writeDelimitationOn: stream.

	title := 'Selecting in finder item Benchmark'.
	stream nextPutAll: title; cr.

	associations := OrderedCollection new.
	bench := GlamourousBenchmark new.
	
	self 
		displayProgressBar:
			[:bar | 
				browserSizes do: [: size |
					res := bench 	measureSelectionTimeInFinderForSize: size.
					stream nextPutAll: res first printString, ' size and selections => ', 
											res second printString, ' ms'; cr.
					associations add: (res first -> res second).
					self incrProgressBar: bar.
			]]
		size: browserSizes size 
		titled: title.
	

	self openMondrianGraphOn: associations titled: title scaleX: 1.0.
	
	
	self writeDelimitationOn: stream.
	stream cr.! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'AlexandreBergel 10/26/2009 17:37'!
writeSelectionMeasurementsOn: stream
	| res browserSizes bench associations title |
	browserSizes := #(100 200 300 400 500 600 700 800 900 1000 1500 2000).
	self writeDelimitationOn: stream.

	title := 'Selecting Item in Browser Benchmark'.
	stream nextPutAll: title; cr.

	associations := OrderedCollection new.
	bench := GlamourousBenchmark new.
	self 
		displayProgressBar:
			[:bar | 
				browserSizes do: [: size |
					res := bench measureSelectionTimeForSize: size.
					stream nextPutAll: res first printString, ' size and selections => ', 
										res second printString, ' ms'; cr.
					associations add: (res first -> res second).
					self incrProgressBar: bar.
			]]
		size: browserSizes size
		titled: title.

	self openMondrianGraphOn: associations titled: title.	
	self writeDelimitationOn: stream.
	stream cr.! !
